//第1頁
TcpModuleFirstPage.prototype._CheckTcpModuleQuantity_ = function () {
  var Return = true;
  var AllNumber = TcpModuleFirstPage.prototype._GetAllNumber_();
  if (AllNumber.length >= 100) {
    Return = false;
  }
  return Return;
};

TcpModuleFirstPage.prototype._LoadLanName_ = function () {
  var Class = new LoadFile();
  var Lan = Class.ReadFile("./File/LAN.json");
  var LanDevice = $("#Main_Center-Content")
    .find(".Body")
    .eq(0)
    .find(".Form")
    .eq(0)
    .find(".Row")
    .eq(0)
    .find(".Select");
  var CopyDialog = $(".Dialog").eq(0).find(".Row").eq(0).find(".Select");
  var RemoveDialog = $(".Dialog").eq(1).find(".Row").eq(0).find(".Select");
  LanDevice.empty();
  CopyDialog.empty();
  RemoveDialog.empty();
  for (var i = 0; i < Lan.length; i++) {
    LanDevice.append($("<option></option>").attr("value", Lan[i]).text(Lan[i]));
    CopyDialog.append(
      $("<option></option>").attr("value", Lan[i]).text(Lan[i])
    );
    RemoveDialog.append(
      $("<option></option>").attr("value", Lan[i]).text(Lan[i])
    );
  }
  Class = null;
};

TcpModuleFirstPage.prototype._LoadIcpdasModule_ = function () {
  if (typeof Global_TcpIcpdasModule != "object") {
    return;
  }

  var LockComPortDevice = new Array();
  var Class = new Algorithm();
  var IcpdasModule = Object.keys(Global_TcpIcpdasModule).sort();
  var IcpdasModuleOptgroup = $("#SelectModule").find("optgroup");
  IcpdasModuleOptgroup.find("option").remove();
  for (var i = 0; i < IcpdasModule.length; i++) {
    if (IcpdasModule[i].indexOf("(P)ET-7") != -1) {
      IcpdasModuleOptgroup.eq(0).append(
        $("<option></option>")
          .attr("value", IcpdasModule[i])
          .text(IcpdasModule[i])
      );
    } else if (IcpdasModule[i].indexOf("DL-") != -1) {
      IcpdasModuleOptgroup.eq(1).append(
        $("<option></option>")
          .attr("value", IcpdasModule[i])
          .text(IcpdasModule[i])
      );
    } else if (IcpdasModule[i].indexOf("WISE-") != -1) {
      IcpdasModuleOptgroup.eq(2).append(
        $("<option></option>")
          .attr("value", IcpdasModule[i])
          .text(IcpdasModule[i])
      );
    } else {
      IcpdasModuleOptgroup.eq(IcpdasModuleOptgroup.length - 1).append(
        $("<option></option>")
          .attr("value", IcpdasModule[i])
          .text(IcpdasModule[i])
      );
    }
  }
};

TcpModuleFirstPage.prototype._ChangeLanDevice_ = function (that) {
  TcpModuleFirstPage.prototype._RedisplayUi_();
};

TcpModuleFirstPage.prototype._GetDeviceName_ = function () {
  //var Return;
  //var Element = $("#Main_Center-Content").find(".Body").eq(0).find(".Form").eq(0).find(".Row").eq(0).find(".Select");
  //Return = Element.val();
  return (Return = "LAN");
};

TcpModuleFirstPage.prototype._GetAllDeviceName_ = function () {
  var Return = new Array();
  var Element = $("#Main_Center-Content")
    .find(".Body")
    .eq(0)
    .find(".Form")
    .eq(0)
    .find(".Row")
    .eq(0)
    .find(".Select");
  var Size = Element.find("option").size();
  for (var i = 0; i < Size; i++) {
    Return.push(Element.find("option").eq(i).val());
  }
  return Return;
};

TcpModuleFirstPage.prototype._GetAllNumber_ = function () {
  var AllDeviceName = TcpModuleFirstPage.prototype._GetAllDeviceName_();
  var ObjectKey = new Array();
  for (var i = 0; i < AllDeviceName.length; i++) {
    ObjectKey = ObjectKey.concat(
      Object.keys(Global_TcpModule[AllDeviceName[i]])
    );
  }
  return ObjectKey;
};

TcpModuleFirstPage.prototype._CreateIcpdasModule_ = function (that) {
  var IcpdasModuleName = $(that).val();
  if (IcpdasModuleName == "-1") {
    return 0;
  }

  var DeviceName = TcpModuleFirstPage.prototype._GetDeviceName_();

  //var Row = $("#ModuleTable").find(".Row").eq(1);
  //var number = Row.find(".Column").eq(1).find(".Select").val();
  var number=$("#Number").val();
  TcpModuleFirstPage.prototype._DeleteRepeatNumber_(number);
  TcpModuleFirstPage.prototype._BuildTcpModuleObject_(IcpdasModuleName, number);
  TcpModuleFirstPage.prototype._CreateTcpSettingObject_(number);
  Global_TcpVariable[number] = new Object();
  Global_TcpVariable[number] = JSON.parse(
    JSON.stringify(Global_TcpIcpdasModule[IcpdasModuleName])
  );
  TcpModuleSecondPage.prototype._SynchronizeOtherServiceData_(number);
  TcpModuleFirstPage.prototype._RedisplayUi_();
  $(that).val("-1");
};

function GetModulesArray(str, delimiter = ",") {
  str = str.replace(/(?:\r)/g, "");
  var temp = str.slice(0, str.indexOf("\n")).split(delimiter);
  const heards = temp.filter(Boolean);
  temp = str
    .slice(str.indexOf("\n") + 1, str.indexOf("VariableName"))
    .split("\n");
  const rows = temp.filter(Boolean);

  const arr = rows.map(function (row) {
    const values = row.split(delimiter);
    const el = heards.reduce(function (object, header, index) {
      object[header] = values[index];
      if (object[header] == "") return "";
      return object;
    }, {});
    return el;
  });
  var filtered = arr.filter(Boolean);
  return filtered;
}

function GetTagsArray(str, delimiter = ",") {
  str = str.replace(/(?:\r)/g, "");
  var temp = str.slice(0).split("\n");
  const index = temp.findIndex((element) => {
    if (element.includes("VariableName,Proprietary")) {
      return true;
    }
    return false;
  });
  const heards = temp[index].split(delimiter);
  var rows = temp.slice(index + 1);
  var arr = [];
  for (var i = 0; i < rows.length; i++) {
    const values = rows[i].split(delimiter);
    if (values[0] == "") continue;
    const el = heards.reduce(function (object, header, index) {
      object[header] = values[index];
      return object;
    }, {});
    arr.push(el);
  }
  return arr;
}

function CreateVariableElement(datatype, property, address) {
  var IOType;

  switch (property) {
    case "0x":
    case "0X":
      IOType = "DO";
      break;

    case "1x":
    case "1X":
      IOType = "DI";
      break;
    case "3x":
    case "3X":
      IOType = "AI";
      break;
    case "4x":
    case "4X":
      IOType = "AO";
      break;
  }
  return IOType + "-" + datatype + "-" + address;
}

function GetAddressNumber(property) {
  switch (property) {
    case "0x":
    case "0X":
      return 1000000;
      break;

    case "1x":
    case "1X":
      return 2000000;
      break;
    case "3x":
    case "3X":
      return 4000000;
      break;

    case "4x":
    case "4X":
      return 3000000;
      break;
  }
}

function CreateModuleVariable(ModuleName, data) {
  var object = new Object();
  for (var i = 0; i < data.length; i++) {
    var subObject = {
      ModbusGroupNumber: 0,
      Address: 0,
      VariableName: "",
      Swap: false,
      Description: "",
    };
    if (data[i].Proprietary == ModuleName) {
      var el = CreateVariableElement(
        data[i].DataType,
        data[i].Function,
        data[i].Address
      );
      var GroupNumber =
        GetAddressNumber(data[i].Function) + data[i].FunctionGroup;
      subObject.ModbusGroupNumber = parseInt(GroupNumber);
      subObject.Address = parseInt(data[i].Address);
      subObject.VariableName = data[i].VariableName;
      var boolval;
      switch (data[i].IsSwap.toLowerCase().trim()) {
        case "true":
        case "1":
          boolval = true;
          break;
        case "false":
        case "0":
          boolval = false;
          break;
        default:
          boolval = false;
          break;
      }
      subObject.Swap = boolval;
      subObject.Description = data[i].Description;
      object[el] = subObject;
    }
  }

  return object;
}

TcpModuleFirstPage.prototype._CreateModuleByCSV_ = function (that, Event) {
  var text, modules, tags;

  const input = Event.target.files[0];
  const reader = new FileReader();

  reader.onload = function (e) {
    text = e.target.result;

    modules = GetModulesArray(text);
    //  console.log(data);
    tags = GetTagsArray(text);
    for (var i = 0; i < modules.length; i++) {

      var number=$("#Number").val();
      TcpModuleFirstPage.prototype._DeleteRepeatNumber_(number);
      TcpModuleFirstPage.prototype._BuildTcpModuleObject_(modules[i].ModuleName,number);
      Global_TcpSetting[number] = new Object();
      Global_TcpSetting[number]["IP"] = modules[i].IP;
      Global_TcpSetting[number]["Port"] = modules[i].Port;
      Global_TcpSetting[number]["SlaveId"] = modules[i].SlaveID;
      Global_TcpSetting[number]["Timeout"] = modules[i].Timeout;
      Global_TcpSetting[number]["PollingRate"] = modules[i].PollingRate;
      Global_TcpVariable[number] = new Object();
      Global_TcpVariable[number] = JSON.parse(JSON.stringify(CreateModuleVariable(modules[i].ModuleName, tags)));
      TcpModuleSecondPage.prototype._SynchronizeOtherServiceData_(number);
      TcpModuleFirstPage.prototype._RedisplayUi_();
    }
  };
  reader.readAsText(input);
};

TcpModuleFirstPage.prototype._UploadFile_ = function (that, Event) {
  var file = Event.target.files[0];
  if (file == null) {
    return 0;
  }

  $(that).closest(".Row").find(".Message").hide();
  $(that).closest(".Row").find(".Loading").eq(0).show();
  TcpModuleFirstPage.prototype._FileTransmission_(that, file);
};

TcpModuleFirstPage.prototype._UpdateFile_ = function (that) {
  $(that).closest(".Row").find(".Message").hide();
  $(that).closest(".Row").find(".Loading").eq(1).show();
  var ssocket = io.connect();
  ssocket.emit("UpdateTcpIcpdasModule");
  ssocket.on("UpdateTcpIcpdasModule", function (Return) {
    if (Return == true) {
      var Class = new LoadFile();
      var TcpIcpdasModule = Class.ReadFile(
        "./File/TCP_Module/TcpIcpdasModule.json"
      );
      $(that).closest(".Row").find(".Loading").hide();
      if (typeof TcpIcpdasModule != "object") {
        $(that).closest(".Row").find(".Message").eq(1).show();
        return;
      }
      Global_TcpIcpdasModule = TcpIcpdasModule;
      TcpModuleFirstPage.prototype._LoadIcpdasModule_();
      $(that).closest(".Row").find(".Message").eq(0).show();
    } else {
      $(that).closest(".Row").find(".Loading").hide();
      $(that).closest(".Row").find(".Message").eq(1).show();
    }
    ssocket.emit("SocketClose");
  });
};

TcpModuleFirstPage.prototype._FileTransmission_ = function (that, file) {
  var ssocket = io.connect();
  var stream = ss.createStream();
  var blobStream = ss.createBlobReadStream(file);

  blobStream.on("data", function (chunk) {
    console.log("data chunk.length:", chunk.length);
  });
  blobStream.on("end", function () {
    $(that).closest("div").find(":file").val("");
    var SetInterval = setInterval(function () {
      TcpModuleFirstPage.prototype._UpdateFile_(that);
      clearInterval(SetInterval);
    }, 500);
  });
  blobStream.pipe(stream);
  ss(ssocket).emit("UploadFile", stream, { name: file.name });
};

TcpModuleFirstPage.prototype._CreateTcpSettingObject_ = function (number) {
  Global_TcpSetting[number] = new Object();
  Global_TcpSetting[number]["IP"] = "0.0.0.0";
  Global_TcpSetting[number]["Port"] = 502;
  Global_TcpSetting[number]["SlaveId"] = 1;
  Global_TcpSetting[number]["Timeout"] = 500;
  Global_TcpSetting[number]["PollingRate"] = 500;
};

TcpModuleFirstPage.prototype._CreateModuleFunction_ = function (number) {
  var DeviceName = TcpModuleFirstPage.prototype._GetDeviceName_();
};

TcpModuleFirstPage.prototype._DeleteRepeatNumber_ = function (number) {
  for (var i = 0; i < Global_TcpIndex.length; i++) {
    if (number == Global_TcpIndex[i]) {
      Global_TcpIndex.splice(i, 1);
    }
  }
};

TcpModuleFirstPage.prototype._BuildTcpModuleAllObject_ = function (that) {
  var number = $(that)
    .closest(".Row")
    .find(".Column")
    .eq(1)
    .find(".Select")
    .val();
  TcpModuleFirstPage.prototype._DeleteRepeatNumber_(number);
  var ModuleName = $(that)
    .closest(".Row")
    .find(".Column")
    .eq(2)
    .find(".Text")
    .val();
  TcpModuleFirstPage.prototype._BuildTcpModuleObject_(ModuleName, number);
  TcpModuleFirstPage.prototype._CreateModuleFunction_(number);
  TcpModuleFirstPage.prototype._CreateTcpSettingObject_(number);
};

TcpModuleFirstPage.prototype._BuildTcpModuleObject_ = function (
  ModuleName,
  number
) {
  var DeviceName = TcpModuleFirstPage.prototype._GetDeviceName_();
  if (typeof Global_TcpModule[DeviceName][number] == "undefined") {
    Global_TcpModule[DeviceName][number] = new Object();
  }
  Global_TcpModule[DeviceName][number]["ModuleName"] = ModuleName;
};

TcpModuleFirstPage.prototype._ShowTable_ = function (ObjectKey, DisplayNumber) {
  var DeviceName = TcpModuleFirstPage.prototype._GetDeviceName_();
  $("#ModuleTable").find(".DynamicRow").remove();
  var html = $(".Dynamic").html();
  var PageNumber = $("#ModuleToolbar").find(".Text").val();
  var Start = (PageNumber - 1) * DisplayNumber;
  if (ObjectKey.length - Start > DisplayNumber) {
    var End = Start + DisplayNumber;
  } else {
    var End = ObjectKey.length;
  }
  var index = 0;
  for (var i = Start; i < End && End != 0; i++) {
    $("#ModuleTable").append(html);
    $("#ModuleTable")
      .find(".DynamicRow")
      .eq(index)
      .find(".Column")
      .eq(1)
      .text(ObjectKey[i]);
    $("#ModuleTable")
      .find(".DynamicRow")
      .eq(index)
      .find(".Column")
      .eq(2)
      .text(Global_TcpModule[DeviceName][ObjectKey[i]]["ModuleName"]);
    index++;
  }
};

TcpModuleFirstPage.prototype._UpdateNumber_ = function (ObjectKey) {
  var AllNumber = TcpModuleFirstPage.prototype._GetAllNumber_();
  AllNumber = AllNumber.sort(function (a, b) {
    return a - b;
  });
  if (AllNumber.length == 0) {
    var MaxNumber = 0;
  } else {
    var MaxNumber = AllNumber[AllNumber.length - 1];
  }
  for (var i = 0; i < Global_TcpIndex.length; i++) {
    if (parseInt(Global_TcpIndex[i]) > parseInt(MaxNumber)) {
      TcpModuleFirstPage.prototype._DeleteRepeatNumber_(Global_TcpIndex[i]);
      i--;
    }
  }
  var DynamicRowLength = ObjectKey.length;
  var TemporaryIndexLength = Global_TcpIndex.length;
  var Id = "#Number";
  $(Id).empty();
  for (var i = 0; i < TemporaryIndexLength; i++) {
    $(Id).append(
      $("<option></option>")
        .attr("value", Global_TcpIndex[i])
        .text(Global_TcpIndex[i])
    );
  }
  $(Id).append(
    $("<option></option>")
      .attr("value", DynamicRowLength + TemporaryIndexLength + 1)
      .text(DynamicRowLength + TemporaryIndexLength + 1)
  );
};

TcpModuleFirstPage.prototype._UpdateTableToolbar_ = function (
  ObjectKey,
  DisplayNumber
) {
  var NumberOfPages = Math.ceil(ObjectKey.length / DisplayNumber);
  var Id = "#ModuleToolbar";
  $(Id).find("label").eq(1).text(NumberOfPages);
  var CurrentlyPage = $(Id).find(".Text").val();
  CurrentlyPage = parseInt(CurrentlyPage);
  if (CurrentlyPage > NumberOfPages) {
    $(Id).find(".Text").val(NumberOfPages);
  } else if (CurrentlyPage <= 0 || isNaN(CurrentlyPage) == true) {
    $(Id).find(".Text").val(1);
  } else {
    $(Id).find(".Text").val(CurrentlyPage);
  }
};

TcpModuleFirstPage.prototype._RedisplayUi_ = function () {
  var DisplayNumber = 20; //RTU 20 TCP 40 ASCII 20
  var DeviceName = TcpModuleFirstPage.prototype._GetDeviceName_();
  var ObjectKey = TcpModuleFirstPage.prototype._GetAllNumber_();
  TcpModuleFirstPage.prototype._UpdateNumber_(ObjectKey);
  ObjectKey = Object.keys(Global_TcpModule[DeviceName]);
  TcpModuleFirstPage.prototype._UpdateTableToolbar_(ObjectKey, DisplayNumber);
  TcpModuleFirstPage.prototype._ShowTable_(ObjectKey, DisplayNumber);
  var Id = "#ModuleTable";
  $(Id).find(".Row").eq(0).find(":checkbox").prop("checked", false);
};

TcpModuleFirstPage.prototype._ModuleAddNewRow_ = function (that) {
  var Id = "#ModuleTable";
  var ShowErrorMessage = $(Id)
    .find(".Row")
    .eq(0)
    .find(".Message")
    .is(":visible");
  if (ShowErrorMessage == true) {
    return 0;
  }
  var OK = TcpModuleFirstPage.prototype._CheckTcpModuleQuantity_();
  if (OK == false) {
    return 0;
  }
  TcpModuleFirstPage.prototype._BuildTcpModuleAllObject_(that);
  TcpModuleFirstPage.prototype._RedisplayUi_();
};

TcpModuleFirstPage.prototype._ShowPreviousPage_ = function () {
  var Id = "#ModuleToolbar";
  var CurrentlyPage = $(Id).find(".Text").val();
  $(Id)
    .find(".Text")
    .val(parseInt(CurrentlyPage) - 1);
  TcpModuleFirstPage.prototype._RedisplayUi_();
};

TcpModuleFirstPage.prototype._ShowNextPage_ = function () {
  var Id = "#ModuleToolbar";
  var CurrentlyPage = $(Id).find(".Text").val();
  $(Id)
    .find(".Text")
    .val(parseInt(CurrentlyPage) + 1);
  TcpModuleFirstPage.prototype._RedisplayUi_();
};

TcpModuleFirstPage.prototype._CopyGlobalVariable_ = function (
  DeviceName,
  CopyToDeviceName,
  number
) {
  var SlaveId;
  var ObjectKey = TcpModuleFirstPage.prototype._GetAllNumber_();
  var Index = ObjectKey.length + Global_TcpIndex.length + 1;
  var CopyNumber = parseInt(
    $(".Dialog")
      .eq(0)
      .find(".DialogTable")
      .find(".Row")
      .eq(1)
      .find(".Text")
      .val()
  );
  for (j = 0; j < CopyNumber; j++) {
    if (SlaveId > 254) {
      break;
    }
    var OK = TcpModuleFirstPage.prototype._CheckTcpModuleQuantity_();
    if (OK == false) {
      break;
    }

    if (typeof Global_TcpModule[DeviceName][number] != "undefined") {
      Global_TcpModule[CopyToDeviceName][Index] = jQuery.parseJSON(
        JSON.stringify(Global_TcpModule[DeviceName][number])
      );
    }
    if (typeof Global_TcpSetting[number] != "undefined") {
      Global_TcpSetting[Index] = jQuery.parseJSON(
        JSON.stringify(Global_TcpSetting[number])
      );
    }
    if (typeof Global_TcpVariable[number] != "undefined") {
      Global_TcpVariable[Index] = jQuery.parseJSON(
        JSON.stringify(Global_TcpVariable[number])
      );
    }
    TcpModuleSecondPage.prototype._SynchronizeOtherServiceData_(Index);
    Index++;
  }
};

TcpModuleFirstPage.prototype._CopyTickedModule_ = function () {
  var DeviceName = TcpModuleFirstPage.prototype._GetDeviceName_();
  var CopyToDeviceName = $(".Dialog").eq(0).find(".Row").find(".Select").val();
  var Id = "#ModuleTable";
  var element = $(Id).find(".DynamicRow").find(":checked");
  var CheckedLength = element.length;
  for (var i = 0; i < CheckedLength; i++) {
    number = parseInt(
      element.eq(i).closest(".DynamicRow").find(".Column").eq(1).text()
    );
    TcpModuleFirstPage.prototype._CopyGlobalVariable_(
      DeviceName,
      CopyToDeviceName,
      number
    );
  }
};

TcpModuleFirstPage.prototype._CopyModule_ = function () {
  TcpModuleFirstPage.prototype._CopyTickedModule_();
  TcpModuleFirstPage.prototype._RedisplayUi_();
  TcpModuleFirstPage.prototype._CopyDialogDisabled_();
};

TcpModuleFirstPage.prototype._RemoveGlobalVariable_ = function (
  DeviceName,
  number
) {
  Global_TcpModule[DeviceName][number] = null;
  delete Global_TcpModule[DeviceName][number];
  Global_TcpVariable[number] = null;
  delete Global_TcpVariable[number];
  Global_TcpScalingVariable[number] = null;
  delete Global_TcpScalingVariable[number];
  Global_TcpBitwiseVariable[number] = null;
  delete Global_TcpBitwiseVariable[number];
  Global_TcpSetting[number] = null;
  delete Global_TcpSetting[number];
  Global_TcpIndex.push(number);
  Global_TcpIndex = Global_TcpIndex.sort(function (a, b) {
    return a - b;
  });
  Global_TcpToOpcuaVariable[number] = null;
  delete Global_TcpToOpcuaVariable[number];
  Global_TcpScalingToOpcuaVariable[number] = null;
  delete Global_TcpScalingToOpcuaVariable[number];
  Global_TcpBitwiseToOpcuaVariable[number] = null;
  delete Global_TcpBitwiseToOpcuaVariable[number];
  Global_TcpToMqttSetting[number] = null;
  delete Global_TcpToMqttSetting[number];
  Global_TcpToMqttVariable[number] = null;
  delete Global_TcpToMqttVariable[number];
  Global_TcpToMqttJsonVariable[number] = null;
  delete Global_TcpToMqttJsonVariable[number];
  Global_TcpToMsSqlVariable[number] = null;
  delete Global_TcpToMsSqlVariable[number];
  Global_TcpToMysqlConnectionVariable[number] = null;
  delete Global_TcpToMysqlConnectionVariable[number];
  Global_TcpToLocalDataLoggerVariable[number] = null;
  delete Global_TcpToLocalDataLoggerVariable[number];
  var Class = new ClearService();
  Class.DeleteModuleClearService("MTCP", number);
  Class.DeleteModuleClearService("MTCP Scaling", number);
  Class = null;
};

TcpModuleFirstPage.prototype._RemoveTickedModule_ = function () {
  var DeviceName = TcpModuleFirstPage.prototype._GetDeviceName_();
  var Id = "#ModuleTable";
  var element = $(Id).find(".DynamicRow").find(":checked");
  var CheckedLength = element.length;
  for (var i = 0; i < CheckedLength; i++) {
    number = element.eq(i).closest(".DynamicRow").find(".Column").eq(1).text();
    TcpModuleFirstPage.prototype._RemoveGlobalVariable_(DeviceName, number);
  }
};

TcpModuleFirstPage.prototype._DeleteModule_ = function () {
  TcpModuleFirstPage.prototype._RemoveTickedModule_();
  TcpModuleFirstPage.prototype._RedisplayUi_();
};

TcpModuleFirstPage.prototype._ClearAllModule_ = function (that) {
  var DeviceName = $(that)
    .closest(".Dialog")
    .find(".Row")
    .find(".Select")
    .val();
  var number = Object.keys(Global_TcpModule[DeviceName]);
  for (var i = 0; i < number.length; i++) {
    TcpModuleFirstPage.prototype._RemoveGlobalVariable_(DeviceName, number[i]);
  }
  TcpModuleFirstPage.prototype._RedisplayUi_();
  TcpModuleFirstPage.prototype._ClearDialogDisabled_();
};

TcpModuleFirstPage.prototype._IsTickedModule_ = function () {
  var Return = false;
  var Id = "#ModuleTable";
  if ($(Id).find(".DynamicRow").find(":checked").length > 0) {
    Return = true;
  }
  return Return;
};

TcpModuleFirstPage.prototype._InitializationGlobalVariable_ = function () {
  var AllDeviceName = TcpModuleFirstPage.prototype._GetAllDeviceName_();
  for (var i = 0; i < AllDeviceName.length; i++) {
    if (typeof Global_TcpModule[AllDeviceName[i]] != "object") {
      Global_TcpModule[AllDeviceName[i]] = new Object();
    }
  }
};

TcpModuleFirstPage.prototype._Initialization_ = function () {
  TcpModuleFirstPage.prototype._LoadLanName_();
  TcpModuleFirstPage.prototype._LoadIcpdasModule_();
  TcpModuleFirstPage.prototype._InitializationGlobalVariable_();
  TcpModuleFirstPage.prototype._RedisplayUi_();
};

TcpModuleFirstPage.prototype._CheckModuleName_ = function (that) {
  var DeviceName = TcpModuleFirstPage.prototype._GetDeviceName_();
  var Id = "#ModuleTable";
  $(Id).find(".Row").eq(0).find(".Message").hide();
  var Class = new Type();
  var Name = $(that).closest(".Column").find(".Text").val();
  if (Name == "") {
    $(Id).find(".Row").eq(0).find(".Message").eq(0).show();
  } else if (
    Class.CheckSpecialSymbols_ExcludeBottomLineBrackets(Name) == true
  ) {
    $(Id).find(".Row").eq(0).find(".Message").eq(1).show();
  } else if (Class.CheckChineseLanguage(Name) == true) {
    $(Id).find(".Row").eq(0).find(".Message").eq(1).show();
  }
  Class = null;
};

TcpModuleFirstPage.prototype._CopyDialogEnabled_ = function (Event) {
  var DeviceName = TcpModuleFirstPage.prototype._GetDeviceName_();
  $(".Dialog").eq(0).find(".Row").find(".Select").val(DeviceName);
  $(".Dialog").eq(0).find(".Row").find(".Text").val("1");

  var MouseX = Event.pageX - 250 + "px";
  var MouseY = Event.pageY - 350 + "px";
  $(".Dialog").eq(0).css("left", MouseX);
  $(".Dialog").eq(0).css("top", MouseY);

  var Class = new Dialog();
  Class.CommonDisabled();
  Class = null;

  $("#Main_Center-Content").find(".Body").eq(0).css("pointer-events", "none");
  $("#Main_Center-Content").find(".Body").eq(0).css("opacity", 0.5);

  $(".Dialog").eq(0).css("display", "block");
};

TcpModuleFirstPage.prototype._CopyDialogDisabled_ = function () {
  $(".Dialog").eq(0).find(".Message").hide();
  var Class = new Dialog();
  Class.CommonEnabled();
  Class = null;

  $("#Main_Center-Content")
    .find(".Body")
    .eq(0)
    .css("pointer-events", "visible");
  $("#Main_Center-Content").find(".Body").eq(0).css("opacity", 1);

  $(".Dialog").eq(0).css("display", "none");
  $(".Dialog")
    .eq(0)
    .find(".DialogTable")
    .find(".Row")
    .find(".Column")
    .eq(1)
    .find(".Text")
    .val("");
};

TcpModuleFirstPage.prototype._ClearDialogEnabled_ = function (Event) {
  var MouseX = Event.pageX - 250 + "px";
  var MouseY = Event.pageY - 350 + "px";
  $(".Dialog").eq(1).css("left", MouseX);
  $(".Dialog").eq(1).css("top", MouseY);

  var Class = new Dialog();
  Class.CommonDisabled();
  Class = null;

  $("#Main_Center-Content").find(".Body").eq(0).css("pointer-events", "none");
  $("#Main_Center-Content").find(".Body").eq(0).css("opacity", 0.5);

  $(".Dialog").eq(1).css("display", "block");
};

TcpModuleFirstPage.prototype._ClearDialogDisabled_ = function () {
  var Class = new Dialog();
  Class.CommonEnabled();
  Class = null;

  $("#Main_Center-Content")
    .find(".Body")
    .eq(0)
    .css("pointer-events", "visible");
  $("#Main_Center-Content").find(".Body").eq(0).css("opacity", 1);

  $(".Dialog").eq(1).css("display", "none");
  $(".Dialog")
    .eq(1)
    .find(".DialogTable")
    .find(".Row")
    .find(".Column")
    .eq(1)
    .find(".Text")
    .val("");
};

TcpModuleFirstPage.prototype._EditButton_ = function (that) {
  $("#Main_Center-Content").find(".Body").eq(1).find(".Message").hide();
  var number = parseInt(
    $(that).closest(".DynamicRow").find(".Column").eq(1).text()
  );
  $("#Main_Center-Content").find(".Body").eq(0).hide();
  $("#Main_Center-Content").find(".Body").eq(1).show();
  var Name = $("#Main_Center-Content")
    .find(".Body")
    .eq(1)
    .find(".FormTitle")
    .eq(0)
    .text();
  var Class = new Path();
  Class.LoadPathHtml(Name, 2);
  Class = null;
  TcpModuleSecondPage.prototype._SetInitialValue_(number);
  $("#MappingTable").find(".Tab").eq(3).click();
};

TcpModuleFirstPage.prototype._SaveModuleSetting_ = function (Result) {
  var Result_1 = { Input: null },
    Result_2 = { Input: null },
    Result_3 = { Input: null },
    Result_4 = { Input: null },
    Result_5 = { Input: null },
    Result_6 = { Input: null };
  var Class = new Transmission();
  Class.TransmissionString(
    "SaveTcpIndex",
    JSON.stringify(Global_TcpIndex),
    Result_1
  );
  Class.TransmissionString(
    "SaveTcpModule",
    JSON.stringify(Global_TcpModule),
    Result_2
  );
  Class.TransmissionString(
    "SaveTcpVariable",
    JSON.stringify(Global_TcpVariable),
    Result_3
  );
  Class.TransmissionString(
    "SaveTcpSetting",
    JSON.stringify(Global_TcpSetting),
    Result_4
  );
  Class.TransmissionString(
    "SaveTcpScalingVariable",
    JSON.stringify(Global_TcpScalingVariable),
    Result_5
  );
  Class.TransmissionString(
    "SaveTcpBitwiseVariable",
    JSON.stringify(Global_TcpBitwiseVariable),
    Result_6
  );
  var SetInterval = setInterval(function () {
    if (
      Result_1["Input"] == true &&
      Result_2["Input"] == true &&
      Result_3["Input"] == true &&
      Result_4["Input"] == true &&
      Result_5["Input"] == true &&
      Result_6["Input"] == true
    ) {
      Result["Input"] = true;
      Class = null;
      delete Class;
      clearInterval(SetInterval);
    }
  }, 500);
};

TcpModuleFirstPage.prototype._SaveConvertSetting_ = function (Result) {
  var Result_1 = { Input: null },
    Result_2 = { Input: null },
    Result_3 = { Input: null },
    Result_4 = { Input: null },
    Result_5 = { Input: null },
    Result_6 = { Input: null };
  var Class = new Transmission();
  Class.TransmissionString(
    "SaveTcpToOpcuaVariable",
    JSON.stringify(Global_TcpToOpcuaVariable),
    Result_1
  );
  Class.TransmissionString(
    "SaveTcpToMqttSetting",
    JSON.stringify(Global_TcpToMqttSetting),
    Result_2
  );
  Class.TransmissionString(
    "SaveTcpToMqttVariable",
    JSON.stringify(Global_TcpToMqttVariable),
    Result_3
  );
  Class.TransmissionString(
    "SaveTcpToMqttJsonVariable",
    JSON.stringify(Global_TcpToMqttJsonVariable),
    Result_4
  );
  Class.TransmissionString(
    "SaveTcpScalingToOpcuaVariable",
    JSON.stringify(Global_TcpScalingToOpcuaVariable),
    Result_5
  );
  Class.TransmissionString(
    "SaveTcpBitwiseToOpcuaVariable",
    JSON.stringify(Global_TcpBitwiseToOpcuaVariable),
    Result_6
  );
  var SetInterval = setInterval(function () {
    if (
      Result_1["Input"] == true &&
      Result_2["Input"] == true &&
      Result_3["Input"] == true &&
      Result_4["Input"] == true &&
      Result_5["Input"] == true &&
      Result_6["Input"] == true
    ) {
      Result["Input"] = true;
      Class = null;
      delete Class;
      clearInterval(SetInterval);
    }
  }, 500);
};

TcpModuleFirstPage.prototype._SaveLoggerSetting_ = function (Result) {
  var Result_1 = { Input: null },
    Result_2 = { Input: null },
    Result_3 = { Input: null };
  var Class = new Transmission();
  Class.TransmissionString(
    "SaveTcpToMsSqlVariable",
    JSON.stringify(Global_TcpToMsSqlVariable),
    Result_1
  );
  Class.TransmissionString(
    "SaveTcpToLocalDataLoggerVariable",
    JSON.stringify(Global_TcpToLocalDataLoggerVariable),
    Result_2
  );
  Class.TransmissionString(
    "SaveTcpToMysqlConnectionVariable",
    JSON.stringify(Global_TcpToMysqlConnectionVariable),
    Result_3
  );
  var SetInterval = setInterval(function () {
    if (
      Result_1["Input"] == true &&
      Result_2["Input"] == true &&
      Result_3["Input"] == true
    ) {
      Result["Input"] = true;
      Class = null;
      delete Class;
      clearInterval(SetInterval);
    }
  }, 500);
};

TcpModuleFirstPage.prototype._SaveAdvancedSetting_ = function (Result) {
  var Result_1 = { Input: null },
    Result_2 = { Input: null },
    Result_3 = { Input: null };
  var Class = new Transmission();
  Class.TransmissionString(
    "SaveIftttConditionTriggerSetting",
    JSON.stringify(Global_IftttConditionTriggerSetting),
    Result_1
  );
  Class.TransmissionString(
    "SaveIftttConditionTriggerVariable",
    JSON.stringify(Global_IftttConditionTriggerVariable),
    Result_2
  );
  Class.TransmissionString(
    "SavePidOperationVariable",
    JSON.stringify(Global_PidOperation),
    Result_3
  );
  var SetInterval = setInterval(function () {
    if (
      Result_1["Input"] == true &&
      Result_2["Input"] == true &&
      Result_3["Input"] == true
    ) {
      Result["Input"] = true;
      Class = null;
      delete Class;
      clearInterval(SetInterval);
    }
  }, 500);
};

TcpModuleFirstPage.prototype._SaveDataLayerAndServiceLayerVariables_ =
  function (Result) {
    var RReturn = $.Deferred();
    var Result_1 = { Input: null },
      Result_2 = { Input: null },
      Result_3 = { Input: null },
      Result_4 = { Input: null };
    TcpModuleFirstPage.prototype._SaveModuleSetting_(Result_1);
    TcpModuleFirstPage.prototype._SaveConvertSetting_(Result_2);
    TcpModuleFirstPage.prototype._SaveLoggerSetting_(Result_3);
    TcpModuleFirstPage.prototype._SaveAdvancedSetting_(Result_4);
    var SetInterval = setInterval(function () {
      if (
        Result_1["Input"] == true &&
        Result_2["Input"] == true &&
        Result_3["Input"] == true &&
        Result_4["Input"] == true
      ) {
        Result["Input"] = true;
        clearInterval(SetInterval);
        RReturn.resolve(true);
      }
    }, 500);
    return RReturn.promise();
  };

TcpModuleFirstPage.prototype._SaveButton_ = function (that) {
  var Result = { Input: null };
  $(that).closest(".Row").find(".Loading").show();
  $(that).closest(".Row").find(".Message").hide();
  TcpModuleFirstPage.prototype._SaveDataLayerAndServiceLayerVariables_(Result);
  var SetInterval = setInterval(function () {
    if (Result["Input"] == true) {
      $(that).closest(".Row").find(".Loading").hide();
      $(that).closest(".Row").find(".Message").eq(0).show();
      clearInterval(SetInterval);
    }
  }, 500);
};

//第2頁
TcpModuleSecondPage.prototype._GetDataModelTableOldData_ = function (
  DataModelId
) {
  DataModelId = DataModelId + "Table";
  var Return = new Object();
  var length = $("#" + DataModelId).find(".DynamicRow").length;
  var Address, Variable, DataType, Swap, Description;

  for (var i = 0; i < length; i++) {
    Address = parseInt(
      $("#" + DataModelId)
        .find(".DynamicRow")
        .eq(i)
        .find(".Column")
        .eq(0)
        .text()
    );
    Return[Address] = new Object();
    Variable = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(1)
      .find(":text")
      .val();
    Return[Address]["VariableName"] = Variable;
    DataType = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(2)
      .text();
    Return[Address]["DataType"] = DataType;
    Swap = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(3)
      .find(".Checkbox")
      .prop("checked");
    Return[Address]["Swap"] = Swap;
    Description = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(4)
      .find(":text")
      .val();
    Return[Address]["Description"] = Description;
  }
  return Return;
};

TcpModuleSecondPage.prototype._GetScalingTableOldData_ = function (
  DataModelId
) {
  DataModelId = "Scaling" + DataModelId + "Table";
  var Return = new Object();
  var length = $("#" + DataModelId).find(".DynamicRow").length;
  var Variable,
    InputDataMin,
    InputDataMax,
    OutputDataMin,
    OutputDataMax,
    ScaleVariableName,
    Offset,
    TransformScaling,
    Description,
    DataType;

  for (var i = 0; i < length; i++) {
    Address = parseInt(
      $("#" + DataModelId)
        .find(".DynamicRow")
        .eq(i)
        .find(".Column")
        .eq(0)
        .text()
    );
    Return[Address] = new Object();
    Variable = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(1)
      .find(":text")
      .eq(0)
      .val();
    Return[Address]["VariableName"] = Variable;
    InputDataMin = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(1)
      .find(":text")
      .eq(1)
      .val();
    Return[Address]["InputDataMin"] = InputDataMin;
    InputDataMax = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(1)
      .find(":text")
      .eq(2)
      .val();
    Return[Address]["InputDataMax"] = InputDataMax;
    ScaleVariableName = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(2)
      .find(":text")
      .eq(0)
      .val();
    Return[Address]["ScaleVariableName"] = ScaleVariableName;
    OutputDataMin = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(2)
      .find(":text")
      .eq(1)
      .val();
    Return[Address]["OutputDataMin"] = OutputDataMin;
    OutputDataMax = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(2)
      .find(":text")
      .eq(2)
      .val();
    Return[Address]["OutputDataMax"] = OutputDataMax;
    Offset = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(2)
      .find(":text")
      .eq(3)
      .val();
    Return[Address]["Offset"] = Offset;
    TransformScaling = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(4)
      .find(":Checkbox")
      .prop("checked");
    Return[Address]["TransformScaling"] = TransformScaling;
    Description = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(5)
      .find(":text")
      .val();
    Return[Address]["Description"] = Description;
    DataType = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(6)
      .find(":text")
      .val();
    Return[Address]["DataType"] = DataType;
  }
  return Return;
};

TcpModuleSecondPage.prototype._GetBitwiseTagValue_ = function (
  DataModelId,
  Data,
  number
) {
  var BitNameId = "";
  var BitTotalNumber = 0;
  var EvenColumnCounter = 0,
    OddColumnCounter = 0,
    BitVariable;
  if (Data["DataType"] == "Short" || Data["DataType"] == "Unsigned Short")
    BitTotalNumber = 16;
  else if (Data["DataType"] == "Long" || Data["DataType"] == "Unsigned Long")
    BitTotalNumber = 32;
  for (var i = 0; i < BitTotalNumber; i++) {
    BitNameId = "BitTagName-" + i.toString();
    if (i % 2 == 0) {
      // Even Column
      BitVariable = $("#" + DataModelId)
        .find(".DynamicRow")
        .eq(number)
        .find(".Column")
        .eq(1)
        .find(".Row_2")
        .find(":text")
        .eq(EvenColumnCounter + 1)
        .val();
      EvenColumnCounter = EvenColumnCounter + 2;
    } else if (i % 2 == 1) {
      // Odd Column
      BitVariable = $("#" + DataModelId)
        .find(".DynamicRow")
        .eq(number)
        .find(".Column")
        .eq(2)
        .find(".Row_2")
        .find(":text")
        .eq(OddColumnCounter + 1)
        .val();
      OddColumnCounter = OddColumnCounter + 2;
    }
    if (BitVariable != null && BitVariable != "") {
      Data[BitNameId] = BitVariable;
    }
  }
};

TcpModuleSecondPage.prototype._GetBitwiseTableOldData_ = function (
  DataModelId
) {
  DataModelId = "Bitwise" + DataModelId + "Table";
  var Return = new Object();
  var length = $("#" + DataModelId).find(".DynamicRow").length;
  var Address, Variable, Description, DataType;

  for (var i = 0; i < length; i++) {
    Address = parseInt(
      $("#" + DataModelId)
        .find(".DynamicRow")
        .eq(i)
        .find(".Column")
        .eq(0)
        .text()
    );
    Return[Address] = new Object();
    Variable = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(1)
      .find(":text")
      .eq(0)
      .val();
    Return[Address]["VariableName"] = Variable;
    Description = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(3)
      .find(":text")
      .eq(0)
      .val();
    Return[Address]["Description"] = Description;
    DataType = $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(4)
      .find(":text")
      .eq(0)
      .val();
    Return[Address]["DataType"] = DataType;
    TcpModuleSecondPage.prototype._GetBitwiseTagValue_(
      DataModelId,
      Return[Address],
      i
    );
  }

  return Return;
};

TcpModuleSecondPage.prototype._DataModelTableAddNewRow_ = function (
  DataModelId,
  Data
) {
  var html = "",
    TempHtml = "";
  if (DataModelId == "CoilStatus" || DataModelId == "InputStatus") {
    TempHtml = $(".DioDynamic").html();
  } else if (
    DataModelId == "HoldingRegisters" ||
    DataModelId == "InputRegisters"
  ) {
    TempHtml = $(".AioDynamic").html();
  }
  var ObjectKey = Object.keys(Data);
  for (var i = 0; i < ObjectKey.length; i++) {
    html = html + TempHtml;
  }
  DataModelId = DataModelId + "Table";
  $("#" + DataModelId).append(html);
};

TcpModuleSecondPage.prototype._ScalingTableAddNewRow_ = function (
  DataModelId,
  Data
) {
  var html = "",
    TempHtml = "";
  if (DataModelId == "HoldingRegisters" || DataModelId == "InputRegisters") {
    TempHtml = $(".ScaleAioDynamic").html();
  }
  var ObjectKey = Object.keys(Data);
  for (var i = 0; i < ObjectKey.length; i++) {
    html = html + TempHtml;
  }
  DataModelId = "Scaling" + DataModelId + "Table";
  $("#" + DataModelId).append(html);
};

TcpModuleSecondPage.prototype._AddBitwiseSettingRow_ = function (
  DataModelId,
  Data
) {
  var html = "",
    TempHtml = "";
  var RowNumber;
  var RowName;
  var EvenColumnCounter;
  var OddColumnCounter;
  var Element = $("#" + DataModelId).find(".DynamicRow");
  TempHtml = $(".BitwiseSettingRow").html();

  var ObjectKey = Object.keys(Data);
  for (var i = 0; i < ObjectKey.length; i++) {
    EvenColumnCounter = 0;
    OddColumnCounter = 0;
    if (
      Data[ObjectKey[i]]["DataType"] == "Short" ||
      Data[ObjectKey[i]]["DataType"] == "Unsigned Short"
    )
      RowNumber = 16;
    else if (
      Data[ObjectKey[i]]["DataType"] == "Long" ||
      Data[ObjectKey[i]]["DataType"] == "Unsigned Long"
    )
      RowNumber = 32;
    for (var j = 0; j < RowNumber; j++) {
      RowName = "Bit" + j.toString();
      if (j % 2 == 0) {
        Element.eq(i).find(".Column").eq(1).find(".Row_2").append(TempHtml);
        Element.eq(i)
          .find(".Column")
          .eq(1)
          .find(".Row_2")
          .find(":text")
          .eq(EvenColumnCounter)
          .val(RowName);
        EvenColumnCounter = EvenColumnCounter + 2;
      } else if (j % 2 == 1) {
        Element.eq(i).find(".Column").eq(2).find(".Row_2").append(TempHtml);
        Element.eq(i)
          .find(".Column")
          .eq(2)
          .find(".Row_2")
          .find(":text")
          .eq(OddColumnCounter)
          .val(RowName);
        OddColumnCounter = OddColumnCounter + 2;
      }
    }
  }
};

TcpModuleSecondPage.prototype._BitwiseTableAddNewRow_ = function (
  DataModelId,
  Data
) {
  var html = "",
    TempHtml = "";
  if (DataModelId == "HoldingRegisters" || DataModelId == "InputRegisters") {
    TempHtml = $(".BitwiseAioDynamic").html();
  }
  var ObjectKey = Object.keys(Data);
  for (var i = 0; i < ObjectKey.length; i++) {
    html = html + TempHtml;
  }
  DataModelId = "Bitwise" + DataModelId + "Table";
  $("#" + DataModelId).append(html);
  TcpModuleSecondPage.prototype._AddBitwiseSettingRow_(DataModelId, Data);
};

TcpModuleSecondPage.prototype._SetDataModelTableNewRowValue_ = function (
  DataModelId,
  Data
) {
  DataModelId = DataModelId + "Table";
  var ObjectKey = Object.keys(Data);
  for (var i = 0; i < ObjectKey.length; i++) {
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(0)
      .text(ObjectKey[i]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(1)
      .find(":text")
      .val(Data[ObjectKey[i]]["VariableName"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(2)
      .text(Data[ObjectKey[i]]["DataType"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(3)
      .find(".Checkbox")
      .prop("checked", Data[ObjectKey[i]]["Swap"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(4)
      .find(":text")
      .val(Data[ObjectKey[i]]["Description"]);
  }
};

TcpModuleSecondPage.prototype._SetScalingTableNewRowValue_ = function (
  DataModelId,
  Data
) {
  DataModelId = "Scaling" + DataModelId + "Table";
  var ObjectKey = Object.keys(Data);
  for (var i = 0; i < ObjectKey.length; i++) {
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(0)
      .text(ObjectKey[i]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(1)
      .find(":text")
      .eq(0)
      .val(Data[ObjectKey[i]]["VariableName"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(1)
      .find(":text")
      .eq(1)
      .val(Data[ObjectKey[i]]["InputDataMin"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(1)
      .find(":text")
      .eq(2)
      .val(Data[ObjectKey[i]]["InputDataMax"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(2)
      .find(":text")
      .eq(0)
      .val(Data[ObjectKey[i]]["ScaleVariableName"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(2)
      .find(":text")
      .eq(1)
      .val(Data[ObjectKey[i]]["OutputDataMin"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(2)
      .find(":text")
      .eq(2)
      .val(Data[ObjectKey[i]]["OutputDataMax"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(2)
      .find(":text")
      .eq(3)
      .val(Data[ObjectKey[i]]["Offset"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(4)
      .find(".Checkbox")
      .prop("checked", Data[ObjectKey[i]]["TransformScaling"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(6)
      .find(":text")
      .eq(0)
      .val(Data[ObjectKey[i]]["DataType"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(5)
      .find(":text")
      .eq(0)
      .val(Data[ObjectKey[i]]["Description"]);
  }
};

TcpModuleSecondPage.prototype._SetBitwiseTagValue_ = function (
  DataModelId,
  Data,
  number
) {
  var BitNameId = "";
  var BitTotalNumber = 0;
  var EvenColumnCounter = 0,
    OddColumnCounter = 0;
  if (Data["DataType"] == "Short" || Data["DataType"] == "Unsigned Short")
    BitTotalNumber = 16;
  else if (Data["DataType"] == "Long" || Data["DataType"] == "Unsigned Long")
    BitTotalNumber = 32;
  for (var i = 0; i < BitTotalNumber; i++) {
    BitNameId = "BitTagName-" + i.toString();
    if (i % 2 == 0) {
      // Even Column
      $("#" + DataModelId)
        .find(".DynamicRow")
        .eq(number)
        .find(".Column")
        .eq(1)
        .find(".Row_2")
        .find(":text")
        .eq(EvenColumnCounter + 1)
        .val(Data[BitNameId]);
      EvenColumnCounter = EvenColumnCounter + 2;
    } else if (i % 2 == 1) {
      // Odd Column
      $("#" + DataModelId)
        .find(".DynamicRow")
        .eq(number)
        .find(".Column")
        .eq(2)
        .find(".Row_2")
        .find(":text")
        .eq(OddColumnCounter + 1)
        .val(Data[BitNameId]);
      OddColumnCounter = OddColumnCounter + 2;
    }
  }
};

TcpModuleSecondPage.prototype._SetBitwiseTableNewRowValue_ = function (
  DataModelId,
  Data
) {
  DataModelId = "Bitwise" + DataModelId + "Table";
  var ObjectKey = Object.keys(Data);
  for (var i = 0; i < ObjectKey.length; i++) {
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(0)
      .text(ObjectKey[i]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(1)
      .find(":text")
      .eq(0)
      .val(Data[ObjectKey[i]]["VariableName"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(4)
      .find(":text")
      .eq(0)
      .val(Data[ObjectKey[i]]["DataType"]);
    $("#" + DataModelId)
      .find(".DynamicRow")
      .eq(i)
      .find(".Column")
      .eq(3)
      .find(":text")
      .eq(0)
      .val(Data[ObjectKey[i]]["Description"]);

    TcpModuleSecondPage.prototype._SetBitwiseTagValue_(
      DataModelId,
      Data[ObjectKey[i]],
      i
    );
  }
};

TcpModuleSecondPage.prototype._GetTotalTableOldData_ = function (DataModelId) {
  var object = new Object(),
    StartAddress,
    DataNumber,
    DataType;
  var TotalTableId = DataModelId + "TotalTable";
  var Element = $("#" + TotalTableId).find(".DynamicRow");
  var Length = Element.length;
  for (var i = 0; i < Length; i++) {
    StartAddress = parseInt(
      Element.eq(i).find(".Row").eq(0).find("label").text()
    );
    DataNumber = Element.eq(i).find(".Row").eq(1).find("label").text();
    DataType = Element.eq(i).find(".Row").eq(2).find("label").text();
    object[StartAddress] = new Object();
    object[StartAddress]["DataNumber"] = DataNumber;
    object[StartAddress]["DataType"] = DataType;
  }
  return object;
};

TcpModuleSecondPage.prototype._TotalTableAddNewRow_ = function (
  DataModelId,
  Data
) {
  var html = "",
    TempHtml = "",
    TotalTableId = DataModelId + "TotalTable";
  if (DataModelId == "CoilStatus" || DataModelId == "InputStatus") {
    TempHtml = $(".TotalTableDynamic").html();
  } else if (
    DataModelId == "HoldingRegisters" ||
    DataModelId == "InputRegisters"
  ) {
    TempHtml = $(".TotalTableDynamic").html();
  }
  var ObjectKey = Object.keys(Data);
  for (var i = 0; i < ObjectKey.length; i++) {
    html = html + TempHtml;
  }
  $("#" + TotalTableId).append(html);
};

TcpModuleSecondPage.prototype._AddTotalTableData_ = function (
  StartAddress,
  DataNumber,
  DataType,
  Data
) {
  if (typeof Data[StartAddress] == "undefined") {
    Data[StartAddress] = new Object();
    Data[StartAddress]["DataNumber"] = DataNumber;
    Data[StartAddress]["DataType"] = DataType;
  }
  return Data;
};

TcpModuleSecondPage.prototype._SetTotalTableNewRowValue_ = function (
  DataModelId,
  Data
) {
  var TotalTableId = DataModelId + "TotalTable";
  var Element = $("#" + TotalTableId).find(".DynamicRow");
  var ObjectKey = Object.keys(Data);
  for (var i = 0; i < ObjectKey.length; i++) {
    Element.eq(i).find(".Row").eq(0).find("label").text(ObjectKey[i]);
    Element.eq(i).find(".Row").eq(0).find(":text").val(ObjectKey[i]);
    Element.eq(i)
      .find(".Row")
      .eq(1)
      .find("label")
      .text(Data[ObjectKey[i]]["DataNumber"]);
    Element.eq(i)
      .find(".Row")
      .eq(1)
      .find(":text")
      .val(Data[ObjectKey[i]]["DataNumber"]);
    Element.eq(i)
      .find(".Row")
      .eq(2)
      .find("label")
      .text(Data[ObjectKey[i]]["DataType"]);
  }
};

TcpModuleSecondPage.prototype._GetItemTableValue_ = function (that) {
  var Return = new Object();
  var Element = $(that).closest(".DynamicRow").find(".Row");
  var LabelStartAddress = parseInt(
    $(that).closest(".DynamicRow").find(".Row").eq(0).find("label").text()
  );
  var TextStartAddress = parseInt(
    $(that).closest(".DynamicRow").find(".Row").eq(0).find(":text").val()
  );
  var LabelNumber = parseInt(
    $(that).closest(".DynamicRow").find(".Row").eq(1).find("label").text()
  );
  var TextNumber = parseInt(
    $(that).closest(".DynamicRow").find(".Row").eq(1).find(":text").val()
  );
  var DataType = $(that)
    .closest(".DynamicRow")
    .find(".Row")
    .eq(2)
    .find("label")
    .text();
  var DataModel = $(that)
    .closest(".Table")
    .attr("id")
    .replace("TotalTable", "");
  Return["DataModel"] = DataModel;
  Return["LabelStartAddress"] = LabelStartAddress;
  Return["TextStartAddress"] = TextStartAddress;
  Return["LabelNumber"] = LabelNumber;
  Return["TextNumber"] = TextNumber;
  Return["DataType"] = DataType;
  return Return;
};

TcpModuleSecondPage.prototype._GetSettingFormValue_ = function () {
  var DataModel,
    StartAddress,
    DataNumber,
    DataType,
    object = new Object();
  object["DataModel"] = $("#SettingForm")
    .find(".Row")
    .eq(0)
    .find(".Select")
    .val();
  object["StartAddress"] = parseInt(
    $("#SettingForm").find(".Row").eq(1).find(".Text").val()
  );
  object["DataNumber"] = parseInt(
    $("#SettingForm").find(".Row").eq(2).find(".Text").val()
  );
  if (
    object["DataModel"] == "CoilStatus" ||
    object["DataModel"] == "InputStatus"
  ) {
    object["DataType"] = "Bool";
  } else {
    object["DataType"] = $("#SettingForm")
      .find(".Row")
      .eq(3)
      .find(".Select")
      .val();
  }
  return object;
};

TcpModuleSecondPage.prototype._GetGridNumber_ = function (DataType) {
  var Grid = 0;
  if (
    DataType == "Bool" ||
    DataType == "Short" ||
    DataType == "Unsigned Short"
  ) {
    Grid = 1;
  } else if (
    DataType == "Long" ||
    DataType == "Unsigned Long" ||
    DataType == "Float"
  ) {
    Grid = 2;
  } else if (DataType == "Double" || DataType == "Int64") {
    Grid = 4;
  }
  return Grid;
};

TcpModuleSecondPage.prototype._DeleteDataModelTableData_ = function (
  Data,
  DeleteAddress
) {
  for (var i = 0; i < DeleteAddress.length; i++) {
    Data[DeleteAddress[i]] = null;
    delete Data[DeleteAddress[i]];
  }
  return Data;
};

TcpModuleSecondPage.prototype._AddDataModelTableData_ = function (
  Data,
  AddAddress,
  DataType
) {
  for (var i = 0; i < AddAddress.length; i++) {
    Data[AddAddress[i]] = AddAddress[i];
    Data[AddAddress[i]] = new Object();
    Data[AddAddress[i]]["VariableName"] = "Tag" + AddAddress[i];
    Data[AddAddress[i]]["DataType"] = DataType;
    Data[AddAddress[i]]["Swap"] = false;
    Data[AddAddress[i]]["Description"] = "";
  }
  return Data;
};

TcpModuleSecondPage.prototype._AddScalingTableData_ = function (
  Data,
  AddAddress,
  DataType
) {
  for (var i = 0; i < AddAddress.length; i++) {
    Data[AddAddress[i]] = AddAddress[i];
    Data[AddAddress[i]] = new Object();
    Data[AddAddress[i]]["VariableName"] = "Tag" + AddAddress[i];
    Data[AddAddress[i]]["ScaleVariableName"] = "Scale_" + "Tag" + AddAddress[i];
    Data[AddAddress[i]]["InputDataMin"] = 0;
    Data[AddAddress[i]]["InputDataMax"] = 10;
    Data[AddAddress[i]]["OutputDataMin"] = 20;
    Data[AddAddress[i]]["OutputDataMax"] = 50;
    Data[AddAddress[i]]["TransformScaling"] = false;
    Data[AddAddress[i]]["Offset"] = 0;
    Data[AddAddress[i]]["DataType"] = DataType;
  }
  return Data;
};

TcpModuleSecondPage.prototype._AddBitwiseTableData_ = function (
  Data,
  AddAddress,
  DataType
) {
  for (var i = 0; i < AddAddress.length; i++) {
    Data[AddAddress[i]] = AddAddress[i];
    Data[AddAddress[i]] = new Object();
    Data[AddAddress[i]]["VariableName"] = "Tag" + AddAddress[i];
    Data[AddAddress[i]]["DataType"] = DataType;
  }
  return Data;
};

TcpModuleSecondPage.prototype._GenerateNeedAddAddress_ = function (
  StartAddress,
  DataNumber,
  DataType
) {
  var Return = new Array();
  var Grid = TcpModuleSecondPage.prototype._GetGridNumber_(DataType);
  for (var i = 0; i < DataNumber; i++) {
    Return.push(StartAddress + Grid * i);
  }
  return Return;
};

TcpModuleSecondPage.prototype._GenerateNeedDeleteAddress_ = function (
  StartAddress,
  DataNumber,
  DataType
) {
  var Return = new Array();
  var Grid = TcpModuleSecondPage.prototype._GetGridNumber_(DataType);
  for (var i = 0; i < DataNumber; i++) {
    Return.push(StartAddress + Grid * i);
  }
  return Return;
};

TcpModuleSecondPage.prototype._CompareDataModelTableNeedDeleteAddress_ =
  function (that) {
    var Return = new Array(),
      LabelArray = new Array(),
      TextArray = new Array();
    var obj = TcpModuleSecondPage.prototype._GetItemTableValue_(that);
    var Grid = TcpModuleSecondPage.prototype._GetGridNumber_(obj["DataType"]);

    for (var i = 0; i < obj["LabelNumber"]; i++) {
      LabelArray.push(obj["LabelStartAddress"]);
      obj["LabelStartAddress"] = obj["LabelStartAddress"] + Grid;
    }
    for (var i = 0; i < obj["TextNumber"]; i++) {
      TextArray.push(obj["TextStartAddress"]);
      obj["TextStartAddress"] = obj["TextStartAddress"] + Grid;
    }
    Return = TcpModuleSecondPage.prototype._ArrayComplement_(
      LabelArray,
      TextArray
    );
    return Return;
  };

TcpModuleSecondPage.prototype._CompareDataModelTableNeedAddAddress_ = function (
  that
) {
  var Return = new Array(),
    LabelArray = new Array(),
    TextArray = new Array();
  var obj = TcpModuleSecondPage.prototype._GetItemTableValue_(that);
  var Grid = TcpModuleSecondPage.prototype._GetGridNumber_(obj["DataType"]);
  for (var i = 0; i < obj["LabelNumber"]; i++) {
    LabelArray.push(obj["LabelStartAddress"]);
    obj["LabelStartAddress"] = obj["LabelStartAddress"] + Grid;
  }
  for (var i = 0; i < obj["TextNumber"]; i++) {
    TextArray.push(obj["TextStartAddress"]);
    obj["TextStartAddress"] = obj["TextStartAddress"] + Grid;
  }
  Return = TcpModuleSecondPage.prototype._ArrayComplement_(
    TextArray,
    LabelArray
  );
  return Return;
};

TcpModuleSecondPage.prototype._ItemTableCss_ = function (Mode, that) {
  if (Mode == "Edit") {
    $(that).closest(".DynamicRow").find(".Row").eq(0).find("label").hide();
    $(that).closest(".DynamicRow").find(".Row").eq(0).find(":text").show();
    $(that).closest(".DynamicRow").find(".Row").eq(1).find("label").hide();
    $(that).closest(".DynamicRow").find(".Row").eq(1).find(":text").show();
    $(that).closest(".DynamicRow").find(".Row").eq(3).find(":button").show();
    $(that).closest(".DynamicRow").find(".Row").eq(3).find(":button").show();
    $(that).closest(".DynamicRow").find(".Row").eq(4).show();
    $(that).closest(".DynamicRow").find(".Message").hide();
    $(that).closest(".DynamicRow").find(".Message").eq(0).show();
    $(that).hide();
  } else if (Mode == "Save" || Mode == "Cancel") {
    $(that).closest(".DynamicRow").find(".Row").eq(0).find("label").show();
    $(that).closest(".DynamicRow").find(".Row").eq(0).find(":text").hide();
    $(that).closest(".DynamicRow").find(".Row").eq(1).find("label").show();
    $(that).closest(".DynamicRow").find(".Row").eq(1).find(":text").hide();
    $(that).closest(".DynamicRow").find(".Row").eq(3).find(":button").hide();
    $(that).closest(".DynamicRow").find(".Row").eq(3).find(":button").hide();
    $(that).closest(".DynamicRow").find(".Row").eq(4).hide();
    $(that).closest(".DynamicRow").find(".Message").hide();
    $(that)
      .closest(".DynamicRow")
      .find(".Row")
      .eq(3)
      .find(":button")
      .eq(1)
      .show();
  }
};

TcpModuleSecondPage.prototype._DeleteScalingDynamicRow_ = function (
  StartAddress,
  number,
  TableId
) {
  var Address, Index;

  TableId = "Scaling" + TableId;
  var element = $("#" + TableId).find(".DynamicRow");
  for (var i = 0; i < element.length; i++) {
    Address = parseInt(element.eq(i).find(".Column").eq(0).text());
    if (StartAddress == Address) {
      Index = i;
      break;
    }
  }
  for (var i = 0; i < number; i++) {
    element.eq(Index + i).remove();
  }
};

TcpModuleSecondPage.prototype._DeleteBitwiseDynamicRow_ = function (
  StartAddress,
  number,
  TableId
) {
  var Address, Index;

  TableId = "Bitwise" + TableId;
  var element = $("#" + TableId).find(".DynamicRow");
  for (var i = 0; i < element.length; i++) {
    Address = parseInt(element.eq(i).find(".Column").eq(0).text());
    if (StartAddress == Address) {
      Index = i;
      break;
    }
  }
  for (var i = 0; i < number; i++) {
    element.eq(Index + i).remove();
  }
};

TcpModuleSecondPage.prototype._ModifyBitwiseTableData_ = function (
  that,
  DataModelId,
  Obj
) {
  var Data =
    TcpModuleSecondPage.prototype._GetBitwiseTableOldData_(DataModelId);
  $("#" + "Bitwise" + DataModelId + "Table")
    .find(".DynamicRow")
    .remove();

  var DeleteAddress =
    TcpModuleSecondPage.prototype._CompareDataModelTableNeedDeleteAddress_(
      that
    );
  var AddAddress =
    TcpModuleSecondPage.prototype._CompareDataModelTableNeedAddAddress_(that);
  Data = TcpModuleSecondPage.prototype._DeleteDataModelTableData_(
    Data,
    DeleteAddress
  );
  Data = TcpModuleSecondPage.prototype._AddBitwiseTableData_(
    Data,
    AddAddress,
    Obj["DataType"]
  );

  TcpModuleSecondPage.prototype._BitwiseTableAddNewRow_(DataModelId, Data);
  TcpModuleSecondPage.prototype._SetBitwiseTableNewRowValue_(DataModelId, Data);
};

TcpModuleSecondPage.prototype._ModifyScalingTableData_ = function (
  that,
  DataModelId,
  Obj
) {
  var Data =
    TcpModuleSecondPage.prototype._GetScalingTableOldData_(DataModelId);
  $("#" + "Scaling" + DataModelId + "Table")
    .find(".DynamicRow")
    .remove();

  var DeleteAddress =
    TcpModuleSecondPage.prototype._CompareDataModelTableNeedDeleteAddress_(
      that
    );
  var AddAddress =
    TcpModuleSecondPage.prototype._CompareDataModelTableNeedAddAddress_(that);
  Data = TcpModuleSecondPage.prototype._DeleteDataModelTableData_(
    Data,
    DeleteAddress
  );
  Data = TcpModuleSecondPage.prototype._AddScalingTableData_(
    Data,
    AddAddress,
    Obj["DataType"]
  );

  TcpModuleSecondPage.prototype._ScalingTableAddNewRow_(DataModelId, Data);
  TcpModuleSecondPage.prototype._SetScalingTableNewRowValue_(DataModelId, Data);
};

TcpModuleSecondPage.prototype._ModifyDataModelTableData_ = function (
  that,
  DataModelId,
  Obj
) {
  var Data =
    TcpModuleSecondPage.prototype._GetDataModelTableOldData_(DataModelId);
  $("#" + DataModelId + "Table")
    .find(".DynamicRow")
    .remove();

  var DeleteAddress =
    TcpModuleSecondPage.prototype._CompareDataModelTableNeedDeleteAddress_(
      that
    );
  var AddAddress =
    TcpModuleSecondPage.prototype._CompareDataModelTableNeedAddAddress_(that);
  Data = TcpModuleSecondPage.prototype._DeleteDataModelTableData_(
    Data,
    DeleteAddress
  );
  Data = TcpModuleSecondPage.prototype._AddDataModelTableData_(
    Data,
    AddAddress,
    Obj["DataType"]
  );

  TcpModuleSecondPage.prototype._DataModelTableAddNewRow_(DataModelId, Data);
  TcpModuleSecondPage.prototype._SetDataModelTableNewRowValue_(
    DataModelId,
    Data
  );
};

TcpModuleSecondPage.prototype._OkButton_ = function (that) {
  var Obj = TcpModuleSecondPage.prototype._GetItemTableValue_(that);
  var Bool = TcpModuleSecondPage.prototype._CheckZoomAddressCollision_(that);
  if (Bool == true) {
    $(that).closest(".DynamicRow").find(".Message").hide();
    $(that).closest(".DynamicRow").find(".Message").eq(1).show();
    return 0;
  }
  var DataModelId = $(that)
    .closest(".Table")
    .attr("id")
    .replace("TotalTable", "");
  TcpModuleSecondPage.prototype._ModifyDataModelTableData_(
    that,
    DataModelId,
    Obj
  );
  TcpModuleSecondPage.prototype._ModifyScalingTableData_(
    that,
    DataModelId,
    Obj
  );
  TcpModuleSecondPage.prototype._ModifyBitwiseTableData_(
    that,
    DataModelId,
    Obj
  );

  var Address = parseInt(
    $(that).closest(".DynamicRow").find(".Row").eq(0).find(":text").val()
  );
  $(that).closest(".DynamicRow").find(".Row").eq(0).find("label").text(Address);
  var number = parseInt(
    $(that).closest(".DynamicRow").find(".Row").eq(1).find(":text").val()
  );
  $(that).closest(".DynamicRow").find(".Row").eq(1).find("label").text(number);

  TcpModuleSecondPage.prototype._ItemTableCss_("Save", that);
};

TcpModuleSecondPage.prototype._CancelButton_ = function (that) {
  var StartAddress = parseInt(
    $(that).closest(".DynamicRow").find(".Row").eq(0).find("label").text()
  );
  $(that)
    .closest(".DynamicRow")
    .find(".Row")
    .eq(0)
    .find(":text")
    .val(StartAddress);

  var number = parseInt(
    $(that).closest(".DynamicRow").find(".Row").eq(1).find("label").text()
  );
  $(that).closest(".DynamicRow").find(".Row").eq(1).find(":text").val(number);

  TcpModuleSecondPage.prototype._ItemTableCss_("Cancel", that);
};

TcpModuleSecondPage.prototype._EditButton_ = function (that) {
  TcpModuleSecondPage.prototype._ItemTableCss_("Edit", that);
};
//快速刪除
TcpModuleSecondPage.prototype._DeleteButton_ = function (that) {
  var StartAddress = parseInt(
    $(that).closest(".DynamicRow").find(".Row").eq(0).find("label").text()
  );
  var number = parseInt(
    $(that).closest(".DynamicRow").find(".Row").eq(1).find("label").text()
  );
  var Address, Index;
  var TableId = $(that).closest(".Table").attr("id");
  TableId = TableId.replace("TotalTable", "") + "Table";
  var element = $("#" + TableId).find(".DynamicRow");
  for (var i = 0; i < element.length; i++) {
    Address = parseInt(element.eq(i).find(".Column").eq(0).text());
    if (StartAddress == Address) {
      Index = i;
      break;
    }
  }
  for (var i = 0; i < number; i++) {
    element.eq(Index + i).remove();
  }
  $(that).closest(".DynamicRow").remove();
  TcpModuleSecondPage.prototype._DeleteScalingDynamicRow_(
    StartAddress,
    number,
    TableId
  );
  TcpModuleSecondPage.prototype._DeleteBitwiseDynamicRow_(
    StartAddress,
    number,
    TableId
  );
};

TcpModuleSecondPage.prototype._ScaleRangeSettingEnabled_ = function (that) {
  $(that).closest(".DynamicRow").find(".Column").eq(1).find(".Row_2").show();
  $(that).closest(".DynamicRow").find(".Column").eq(2).find(".Row_2").show();
  $(that)
    .closest(".DynamicRow")
    .find(".Column")
    .eq(3)
    .find(".ScaleSettingDisabled")
    .show();
  $(that)
    .closest(".DynamicRow")
    .find(".Column")
    .eq(3)
    .find(".ScaleSettingEnabled")
    .hide();
};

TcpModuleSecondPage.prototype._ScaleRangeSettingDisabled_ = function (that) {
  $(that).closest(".DynamicRow").find(".Column").eq(1).find(".Row_2").hide();
  $(that).closest(".DynamicRow").find(".Column").eq(2).find(".Row_2").hide();
  $(that)
    .closest(".DynamicRow")
    .find(".Column")
    .eq(3)
    .find(".ScaleSettingDisabled")
    .hide();
  $(that)
    .closest(".DynamicRow")
    .find(".Column")
    .eq(3)
    .find(".ScaleSettingEnabled")
    .show();
};

TcpModuleSecondPage.prototype._BitwiseSettingEnabled_ = function (that) {
  $(that).closest(".DynamicRow").find(".Column").eq(1).find(".Row_2").show();
  $(that).closest(".DynamicRow").find(".Column").eq(2).find(".Row_2").show();
  $(that)
    .closest(".DynamicRow")
    .find(".Column")
    .eq(2)
    .find(".BitwiseSettingDisabled")
    .show();
  $(that)
    .closest(".DynamicRow")
    .find(".Column")
    .eq(2)
    .find(".BitwiseSettingEnabled")
    .hide();
};

TcpModuleSecondPage.prototype._BitwiseSettingDisabled_ = function (that) {
  $(that).closest(".DynamicRow").find(".Column").eq(1).find(".Row_2").hide();
  $(that).closest(".DynamicRow").find(".Column").eq(2).find(".Row_2").hide();
  $(that)
    .closest(".DynamicRow")
    .find(".Column")
    .eq(2)
    .find(".BitwiseSettingDisabled")
    .hide();
  $(that)
    .closest(".DynamicRow")
    .find(".Column")
    .eq(2)
    .find(".BitwiseSettingEnabled")
    .show();
};

TcpModuleSecondPage.prototype._CreateBitwiseTable_ = function (
  DataModelId,
  Obj
) {
  var Data =
    TcpModuleSecondPage.prototype._GetBitwiseTableOldData_(DataModelId);
  $("#" + "Bitwise" + DataModelId + "Table")
    .find(".DynamicRow")
    .remove();
  var InsertAddress = TcpModuleSecondPage.prototype._GenerateNeedAddAddress_(
    Obj["StartAddress"],
    Obj["DataNumber"],
    Obj["DataType"]
  );
  Data = TcpModuleSecondPage.prototype._AddBitwiseTableData_(
    Data,
    InsertAddress,
    Obj["DataType"]
  );
  TcpModuleSecondPage.prototype._BitwiseTableAddNewRow_(DataModelId, Data);
  TcpModuleSecondPage.prototype._SetBitwiseTableNewRowValue_(DataModelId, Data);
};

TcpModuleSecondPage.prototype._CreateScalingTable_ = function (
  DataModelId,
  Obj
) {
  var Data =
    TcpModuleSecondPage.prototype._GetScalingTableOldData_(DataModelId);
  $("#" + "Scaling" + DataModelId + "Table")
    .find(".DynamicRow")
    .remove();
  var InsertAddress = TcpModuleSecondPage.prototype._GenerateNeedAddAddress_(
    Obj["StartAddress"],
    Obj["DataNumber"],
    Obj["DataType"]
  );
  Data = TcpModuleSecondPage.prototype._AddScalingTableData_(
    Data,
    InsertAddress,
    Obj["DataType"]
  );
  TcpModuleSecondPage.prototype._ScalingTableAddNewRow_(DataModelId, Data);
  TcpModuleSecondPage.prototype._SetScalingTableNewRowValue_(DataModelId, Data);
};

TcpModuleSecondPage.prototype._CreateTable_ = function (DataModelId, that) {
  var Obj = TcpModuleSecondPage.prototype._GetSettingFormValue_();

  var Data = TcpModuleSecondPage.prototype._GetTotalTableOldData_(DataModelId);
  $("#" + DataModelId + "TotalTable")
    .find(".DynamicRow")
    .remove();
  Data = TcpModuleSecondPage.prototype._AddTotalTableData_(
    Obj["StartAddress"],
    Obj["DataNumber"],
    Obj["DataType"],
    Data
  );
  TcpModuleSecondPage.prototype._TotalTableAddNewRow_(DataModelId, Data);
  TcpModuleSecondPage.prototype._SetTotalTableNewRowValue_(DataModelId, Data);

  Data = TcpModuleSecondPage.prototype._GetDataModelTableOldData_(DataModelId);
  $("#" + DataModelId + "Table")
    .find(".DynamicRow")
    .remove();
  var InsertAddress = TcpModuleSecondPage.prototype._GenerateNeedAddAddress_(
    Obj["StartAddress"],
    Obj["DataNumber"],
    Obj["DataType"]
  );
  Data = TcpModuleSecondPage.prototype._AddDataModelTableData_(
    Data,
    InsertAddress,
    Obj["DataType"]
  );
  TcpModuleSecondPage.prototype._DataModelTableAddNewRow_(DataModelId, Data);
  TcpModuleSecondPage.prototype._SetDataModelTableNewRowValue_(
    DataModelId,
    Data
  );

  if (DataModelId == "HoldingRegisters" || DataModelId == "InputRegisters") {
    TcpModuleSecondPage.prototype._CreateScalingTable_(DataModelId, Obj);
    if (
      Obj["DataType"] != "Float" &&
      Obj["DataType"] != "Double" &&
      Obj["DataType"] != "Int64"
    ) {
      TcpModuleSecondPage.prototype._CreateBitwiseTable_(DataModelId, Obj);
    }
  }

  $(that).closest(".Row").find(".Message").eq(0).show();
  $(that).closest(".Row").find(".Message").eq(1).hide();
};

TcpModuleSecondPage.prototype._ProduceTable_ = function (that) {
  var Obj = TcpModuleSecondPage.prototype._GetSettingFormValue_();
  var Bool = TcpModuleSecondPage.prototype._CheckAddressCollision_(
    Obj["DataModel"],
    Obj["StartAddress"],
    Obj["DataNumber"],
    Obj["DataType"]
  );
  if (Bool == true) {
    $(that).closest(".Row").find(".Message").hide();
    $(that).closest(".Row").find(".Message").eq(2).show();
    return 0;
  }
  $(that).closest(".Row").find(".Message").hide();
  $(that).closest(".Row").find(".Message").eq(1).show();

  var DataModelId = $(that)
    .closest(".Form")
    .find(".Row")
    .eq(0)
    .find(".Select")
    .val();

  setTimeout(function () {
    TcpModuleSecondPage.prototype._CreateTable_(DataModelId, that);
  }, 500);
};

TcpModuleSecondPage.prototype._ClearAllCss_ = function (that) {
  $(that).parent("div").find(".Tab").css("border-right-color", "#FFFFFF");
  $(that).parent("div").find(".Tab").css("border-left-color", "#FFFFFF");
  $(that).parent("div").find(".Tab").css("border-top-color", "#FFFFFF");
  $(that).parent("div").find(".Tab").css("background-color", "#FFFFFF");
};

TcpModuleSecondPage.prototype._ChangeCurrentlyTabCss_ = function (that) {
  $(that).css("border-right-color", "#395d8b");
  $(that).css("border-left-color", "#395d8b");
  $(that).css("border-top-color", "#395d8b");
  $(that).css("background-color", "#E5F1FF");
};

TcpModuleSecondPage.prototype._HideAllTotalTable_ = function () {
  $("#CoilStatusTotalTable").css("display", "none");
  $("#InputStatusTotalTable").css("display", "none");
  $("#HoldingRegistersTotalTable").css("display", "none");
  $("#InputRegistersTotalTable").css("display", "none");
};

TcpModuleSecondPage.prototype._ShowAllTotalTable_ = function () {
  $("#CoilStatusTotalTable").css("display", "table");
  $("#InputStatusTotalTable").css("display", "table");
  $("#HoldingRegistersTotalTable").css("display", "table");
  $("#InputRegistersTotalTable").css("display", "table");
};

TcpModuleSecondPage.prototype._HideAllDataModelForm_ = function () {
  $("#CoilStatusFormTitle").css("display", "none");
  $("#CoilStatusForm").css("display", "none");
  $("#CoilStatusTable").css("display", "none");

  $("#InputStatusFormTitle").css("display", "none");
  $("#InputStatusForm").css("display", "none");
  $("#InputStatusTable").css("display", "none");

  $("#HoldingRegistersFormTitle").css("display", "none");
  $("#HoldingRegistersForm").css("display", "none");
  $("#HoldingRegistersTable").css("display", "none");

  $("#InputRegistersFormTitle").css("display", "none");
  $("#InputRegistersForm").css("display", "none");
  $("#InputRegistersTable").css("display", "none");
};

TcpModuleSecondPage.prototype._ShowAllDataModelForm_ = function () {
  $("#CoilStatusFormTitle").css("display", "table");
  $("#CoilStatusForm").css("display", "table");
  $("#CoilStatusTable").css("display", "table");

  $("#InputStatusFormTitle").css("display", "table");
  $("#InputStatusForm").css("display", "table");
  $("#InputStatusTable").css("display", "table");

  $("#HoldingRegistersFormTitle").css("display", "table");
  $("#HoldingRegistersForm").css("display", "table");
  $("#HoldingRegistersTable").css("display", "table");

  $("#InputRegistersFormTitle").css("display", "table");
  $("#InputRegistersForm").css("display", "table");
  $("#InputRegistersTable").css("display", "table");
};

TcpModuleSecondPage.prototype._HideScalingTableForm_ = function () {
  $("#ScalingHoldingRegistersFormTitle").css("display", "none");
  $("#ScalingHoldingRegistersForm").css("display", "none");
  $("#ScalingHoldingRegistersTable").css("display", "none");

  $("#ScalingInputRegistersFormTitle").css("display", "none");
  $("#ScalingInputRegistersForm").css("display", "none");
  $("#ScalingInputRegistersTable").css("display", "none");
};

TcpModuleSecondPage.prototype._ShowScalingTableForm_ = function () {
  $("#ScalingHoldingRegistersFormTitle").css("display", "table");
  $("#ScalingHoldingRegistersForm").css("display", "table");
  $("#ScalingHoldingRegistersTable").css("display", "table");

  $("#ScalingInputRegistersFormTitle").css("display", "table");
  $("#ScalingInputRegistersForm").css("display", "table");
  $("#ScalingInputRegistersTable").css("display", "table");
};

TcpModuleSecondPage.prototype._ShowBitwiseTableForm_ = function () {
  $("#BitwiseHoldingRegistersFormTitle").css("display", "table");
  $("#BitwiseHoldingRegistersForm").css("display", "table");
  $("#BitwiseHoldingRegistersTable").css("display", "table");

  $("#BitwiseInputRegistersFormTitle").css("display", "table");
  $("#BitwiseInputRegistersForm").css("display", "table");
  $("#BitwiseInputRegistersTable").css("display", "table");
};

TcpModuleSecondPage.prototype._HideBitwiseTableForm_ = function () {
  $("#BitwiseHoldingRegistersFormTitle").css("display", "none");
  $("#BitwiseHoldingRegistersForm").css("display", "none");
  $("#BitwiseHoldingRegistersTable").css("display", "none");

  $("#BitwiseInputRegistersFormTitle").css("display", "none");
  $("#BitwiseInputRegistersForm").css("display", "none");
  $("#BitwiseInputRegistersTable").css("display", "none");
};

TcpModuleSecondPage.prototype._CheckDataModelTable_ = function () {
  var Return = true;
  if (
    $("#CoilStatusTable").find(".Message").is(":visible") == true ||
    $("#InputStatusTable").find(".Message").is(":visible") == true ||
    $("#HoldingRegistersTable").find(".Message").is(":visible") == true ||
    $("#InputRegistersTable").find(".Message").is(":visible") == true
  ) {
    Return = false;
  }
  return Return;
};

TcpModuleSecondPage.prototype._CheckTotalTable_ = function () {
  var Return = true;
  if (
    $("#CoilStatusTotalTable").find(".Message").is(":visible") == true ||
    $("#InputStatusTotalTable").find(".Message").is(":visible") == true ||
    $("#HoldingRegistersTotalTable").find(".Message").is(":visible") == true ||
    $("#InputRegistersTotalTable").find(".Message").is(":visible") == true
  ) {
    Return = false;
  }
  return Return;
};

TcpModuleSecondPage.prototype._CheckScalingTable_ = function () {
  var Return = true;
  if (
    $("#ScalingHoldingRegistersTable").find(".Message").is(":visible") ==
      true ||
    $("#ScalingInputRegistersTable").find(".Message").is(":visible") == true
  ) {
    Return = false;
  }
  return Return;
};

TcpModuleSecondPage.prototype._CheckBitwiseTable_ = function () {
  var Return = true;
  if (
    $("#BitwiseHoldingRegistersTable").find(".Message").is(":visible") ==
      true ||
    $("#BitwiseInputRegistersTable").find(".Message").is(":visible") == true
  ) {
    Return = false;
  }
  return Return;
};

TcpModuleSecondPage.prototype._ChangeModbusTab_ = function (Mode, that) {
  if (Mode == "AddressTable") {
    if (
      TcpModuleSecondPage.prototype._CheckDataModelTable_() == false ||
      TcpModuleSecondPage.prototype._CheckScalingTable_() == false ||
      TcpModuleSecondPage.prototype._CheckBitwiseTable_() == false
    ) {
      return 0;
    }
  } else if (Mode == "NameSetting") {
    if (
      TcpModuleSecondPage.prototype._CheckTotalTable_() == false ||
      TcpModuleSecondPage.prototype._CheckScalingTable_() == false ||
      TcpModuleSecondPage.prototype._CheckBitwiseTable_() == false
    ) {
      return 0;
    }
  } else if (Mode == "Scaling") {
    if (
      TcpModuleSecondPage.prototype._CheckDataModelTable_() == false ||
      TcpModuleSecondPage.prototype._CheckTotalTable_() == false ||
      TcpModuleSecondPage.prototype._CheckBitwiseTable_() == false
    ) {
      return 0;
    }
  } else if (Mode == "Bitwise") {
    if (
      TcpModuleSecondPage.prototype._CheckDataModelTable_() == false ||
      TcpModuleSecondPage.prototype._CheckTotalTable_() == false ||
      TcpModuleSecondPage.prototype._CheckScalingTable_() == false
    ) {
      return 0;
    }
  }
  TcpModuleSecondPage.prototype._ClearAllCss_(that);
  TcpModuleSecondPage.prototype._ChangeCurrentlyTabCss_(that);
  if (Mode == "AddressTable") {
    TcpModuleSecondPage.prototype._HideAllDataModelForm_();
    TcpModuleSecondPage.prototype._HideScalingTableForm_();
    TcpModuleSecondPage.prototype._HideBitwiseTableForm_();
    TcpModuleSecondPage.prototype._ShowAllTotalTable_();
  } else if (Mode == "NameSetting") {
    TcpModuleSecondPage.prototype._HideAllTotalTable_();
    TcpModuleSecondPage.prototype._HideScalingTableForm_();
    TcpModuleSecondPage.prototype._HideBitwiseTableForm_();
    TcpModuleSecondPage.prototype._ShowAllDataModelForm_();
  } else if (Mode == "Scaling") {
    TcpModuleSecondPage.prototype._HideAllDataModelForm_();
    TcpModuleSecondPage.prototype._HideAllTotalTable_();
    TcpModuleSecondPage.prototype._HideBitwiseTableForm_();
    TcpModuleSecondPage.prototype._ShowScalingTableForm_();
    TcpModuleSecondPage.prototype._SynchronizeScalingBitwiseSourceVariableName_(
      Mode
    );
  } else if (Mode == "Bitwise") {
    TcpModuleSecondPage.prototype._HideAllDataModelForm_();
    TcpModuleSecondPage.prototype._HideAllTotalTable_();
    TcpModuleSecondPage.prototype._HideScalingTableForm_();
    TcpModuleSecondPage.prototype._ShowBitwiseTableForm_();
    TcpModuleSecondPage.prototype._SynchronizeScalingBitwiseSourceVariableName_(
      Mode
    );
  }
};

TcpModuleSecondPage.prototype._SelectDataModelCombobox_ = function () {
  var value = $("#SettingForm").find(".Row").eq(0).find(".Select").val();
  if (value == "CoilStatus" || value == "InputStatus") {
    $("#SettingForm").find(".Row").eq(3).hide();
  } else if (value == "HoldingRegisters" || value == "InputRegisters") {
    $("#SettingForm").find(".Row").eq(3).show();
  }
};

TcpModuleSecondPage.prototype._InitialSettingFormValue_ = function () {
  $("#SettingForm").find(".Row").eq(1).find(".Text").val(0);
  $("#SettingForm").find(".Row").eq(2).find(".Text").val(1);
};

TcpModuleSecondPage.prototype._CheckZoomAddressCollision_ = function (that) {
  var Return = false,
    Grid,
    StartAddress,
    number,
    DataType,
    MaxAddress,
    Address = new Array(),
    ExistAddress = new Array();
  var Obj = TcpModuleSecondPage.prototype._GetItemTableValue_(that);
  StartAddress = parseInt(Obj["TextStartAddress"]);
  Grid = TcpModuleSecondPage.prototype._GetGridNumber_(Obj["DataType"]);
  MaxAddress = StartAddress + Grid * parseInt(Obj["TextNumber"]);
  if (MaxAddress > 65536) {
    return true;
  }
  for (var i = StartAddress; i < MaxAddress; i++) {
    Address.push(i);
  }
  ExistAddress = TcpModuleSecondPage.prototype._GetExistAddress_(that);
  if (
    TcpModuleSecondPage.prototype._ArrayInteraction_(Address, ExistAddress)
      .length > 0
  ) {
    Return = true;
  }
  return Return;
};

TcpModuleSecondPage.prototype._CheckAddressCollision_ = function (
  DataModel,
  StartAddress,
  DataNumber,
  DataType
) {
  var Return = false,
    Address = new Array();
  var Grid = TcpModuleSecondPage.prototype._GetGridNumber_(DataType);
  var MaxAddress = StartAddress + Grid * parseInt(DataNumber);
  if (MaxAddress > 65536) {
    return true;
  }
  for (var i = StartAddress; i < MaxAddress; i++) {
    Address.push(i);
  }
  var ExistAddress = new Array();
  var element = $("#" + DataModel + "Table").find(".DynamicRow");
  for (var i = 0; i < element.length; i++) {
    var address = parseInt(element.eq(i).find(".Column").eq(0).text());
    var dataType = element.eq(i).find(".Column").eq(2).text();
    Grid = TcpModuleSecondPage.prototype._GetGridNumber_(dataType);
    for (var j = 0; j < Grid; j++) {
      ExistAddress.push(address);
      address++;
    }
  }
  if (
    TcpModuleSecondPage.prototype._ArrayInteraction_(Address, ExistAddress)
      .length > 0
  ) {
    Return = true;
  }
  return Return;
};

TcpModuleSecondPage.prototype._CheckStartAddress_ = function (that) {
  var Class = new Type();
  var StatAddress = $(that).val();
  if (Class.CheckPositiveIntegersAndZero(StatAddress) == false) {
    $(that).val(0);
    Class = null;
    return 0;
  }
  if (!(StatAddress >= 0 && StatAddress <= 65535)) {
    $(that).val(0);
    Class = null;
    return 0;
  }
  StatAddress = parseInt(StatAddress);
  $(that).val(StatAddress);
  Class = null;
};

TcpModuleSecondPage.prototype._CheckDataNumber_ = function (that) {
  var Class = new Type();
  var Length = $(that).val();
  if (Class.CheckPositiveIntegers(Length) == false) {
    $(that).val(1);
    Class = null;
    return 0;
  }
  var TableId = $(that).closest(".Table").attr("id");
  var FormId = $(that).closest(".Form").attr("id");
  if (typeof TableId != "undefined") {
    var DataType = TableId.replace("TotalTable", "");
  } else if (typeof FormId != "undefined") {
    var DataType = $("#SettingForm").find(".Row").eq(0).find(".Select").val();
  }
  Length = Class.CheckModbusDataModelMaxQuantity(DataType, parseInt(Length));
  $(that).val(Length);
  Class = null;
};

TcpModuleSecondPage.prototype._CheckPollingTimeout_ = function (that) {
  var Class = new Type();
  var PollingTimeout = $(that).val();
  PollingTimeout = parseInt(PollingTimeout);
  if (
    Class.CheckPositiveIntegers(PollingTimeout) == false ||
    PollingTimeout < 20
  ) {
    $(that).val(20);
    Class = null;
    return 0;
  }
  $(that).val(PollingTimeout);
  Class = null;
};

TcpModuleSecondPage.prototype._CheckPollingRate_ = function (that) {
  var Class = new Type();
  var PollingRate = $(that).val();
  PollingRate = parseInt(PollingRate);
  if (Class.CheckPositiveIntegers(PollingRate) == false || PollingRate < 20) {
    $(that).val(20);
    Class = null;
    return 0;
  }
  $(that).val(PollingRate);
  Class = null;
};

TcpModuleSecondPage.prototype._CheckVariableName_ = function (that) {
  var CurrentlyName;
  var AllName = TcpModuleSecondPage.prototype._GetTableVariableValue_(that);
  var Element = $(that).closest(".Table").find(".DynamicRow");
  Element.find(".Message").hide();
  for (var i = 0; i < Element.length; i++) {
    CurrentlyName = Element.eq(i).find(".Text").val();
    if (TcpModuleSecondPage.prototype._IsNameFormat_(CurrentlyName) == false) {
      Element.eq(i).find(".Message").eq(1).show();
    } else if (
      TcpModuleSecondPage.prototype._IsNameRepeat_(AllName, CurrentlyName) ==
      true
    ) {
      Element.eq(i).find(".Message").eq(0).show();
    }
  }
};

TcpModuleSecondPage.prototype._CheckScalingVariableName_ = function (that) {
  var CurrentlyName;
  var AllName =
    TcpModuleSecondPage.prototype._GetScalingTableVariableValue_(that);
  var Element = $(that).closest(".Table").find(".DynamicRow");
  Element.find(".Message").hide();
  for (var i = 0; i < Element.length; i++) {
    CurrentlyName = Element.eq(i)
      .find(".Column")
      .eq(2)
      .find(":text")
      .eq(0)
      .val();
    if (TcpModuleSecondPage.prototype._IsNameFormat_(CurrentlyName) == false) {
      Element.eq(i).find(".Message").eq(1).show();
    } else if (
      TcpModuleSecondPage.prototype._IsNameRepeat_(AllName, CurrentlyName) ==
      true
    ) {
      Element.eq(i).find(".Message").eq(0).show();
    }
  }
};

TcpModuleSecondPage.prototype._CheckBitwiseVariableName_ = function (that) {
  var CurrentlyName;
  var AllName =
    TcpModuleSecondPage.prototype._GetBitwiseTableVariableValue_(that);
  var Element = $(that).closest(".Table").find(".DynamicRow");
  Element.find(".Message").hide();
  for (var i = 0; i < AllName[0].length; i++) {
    CurrentlyName = AllName[0][i];
    if (CurrentlyName == "") {
      Element.eq(i).find(".Message").eq(1).hide();
      continue;
    } else if (
      TcpModuleSecondPage.prototype._IsNameFormat_(CurrentlyName) == false
    ) {
      Element.eq(AllName[1][i]).find(".Message").eq(1).show();
    } else if (
      TcpModuleSecondPage.prototype._IsNameRepeat_(AllName[0], CurrentlyName) ==
      true
    ) {
      Element.eq(AllName[1][i]).find(".Message").eq(0).show();
    }
  }
};

TcpModuleSecondPage.prototype._CheckModuleName_ = function (that) {
  $(that).closest(".Row").find(".Message").hide();
  var Name = $(that).closest(".Row").find(".Text").val();
  var Class = new Type();
  if (Name == "") {
    $(that).closest(".Row").find(".Message").eq(0).show();
  } else if (
    Class.CheckSpecialSymbols_ExcludeBottomLineBrackets(Name) == true
  ) {
    $(that).closest(".Row").find(".Message").eq(1).show();
  } else if (Class.CheckChineseLanguage(Name) == true) {
    $(that).closest(".Row").find(".Message").eq(1).show();
  }
  Class = null;
};

TcpModuleSecondPage.prototype._CheckIP_ = function (that) {
  $(that).closest(".Row").find(".Message").hide();
  var Element = $(that).closest(".Row").find(".Text");
  var IP =
    Element.eq(0).val() +
    "." +
    Element.eq(1).val() +
    "." +
    Element.eq(2).val() +
    "." +
    Element.eq(3).val();
  var Class = new Type();
  if (Class.CheckIp(IP) == false) {
    $(that).closest(".Row").find(".Message").show();
    return 0;
  }
};

TcpModuleSecondPage.prototype._CheckPort_ = function (that) {
  $(that).closest(".Row").find(".Message").hide();
  var Port = $(that).closest(".Row").find(".Text").val();
  var Class = new Type();
  if (
    Class.CheckPositiveIntegers(Port) == false ||
    !(Port >= 1 && Port <= 65535)
  ) {
    $(that).closest(".Row").find(".Message").show();
    return 0;
  }
};

TcpModuleSecondPage.prototype._CheckSlaveId_ = function (that) {
  var SlaveId = $(that).closest(".Row").find(".Text").val();
  var number = parseInt(
    $(that).closest(".Form").find(".Row").eq(0).find(".Text").val()
  );
  $(that).closest(".Row").find(".Message").hide();

  var Class = new Type();
  if (
    Class.CheckPositiveIntegers(SlaveId) == false ||
    !(parseInt(SlaveId) > 0 && parseInt(SlaveId) < 255)
  ) {
    $(that).closest(".Row").find(".Message").eq(0).show();
    $(that).closest(".Row").find(".Text").val(SlaveId);
    Class = null;
    return 0;
  }
  Class = null;
  /*	var ObjKey = Object.keys(Global_TcpSetting);
		for(var i=0; i<ObjKey.length; i++)
		{
			if(Global_TcpSetting[ObjKey[i]]["SlaveId"] == SlaveId && number != ObjKey[i])
			{
				$(that).closest(".Row").find(".Message").eq(1).show();
				$(that).closest(".Row").find(".Text").val(SlaveId);
				break;
			}
		}*/
};

TcpModuleSecondPage.prototype._GetTableVariableValue_ = function (that) {
  var Length,
    Element,
    AllName = new Array();
  Element = $(that).closest(".Table").find(".DynamicRow");
  Length = Element.length;
  for (var i = 0; i < Length; i++) {
    AllName.push(Element.eq(i).find(".Text").val());
  }
  AllName = AllName.sort(function (a, b) {
    return a - b;
  });
  return AllName;
};

TcpModuleSecondPage.prototype._GetScalingTableVariableValue_ = function (that) {
  var Length,
    Element,
    AllName = new Array();
  Element = $(that).closest(".Table").find(".DynamicRow");
  Length = Element.length;
  for (var i = 0; i < Length; i++) {
    AllName.push(Element.eq(i).find(".Column").eq(2).find(":text").eq(0).val());
  }
  AllName = AllName.sort(function (a, b) {
    return a - b;
  });
  return AllName;
};

TcpModuleSecondPage.prototype._GetBitwiseUIValue_ = function (that) {
  var Return = new Array();
  Return[0] = new Array();
  Return[1] = new Array();
  var BitTotalNumber = 0;
  var BitVariable;
  var EvenColumnCounter = 0;
  var OddColumnCounter = 0;
  var Length, Element, DataType;

  Element = $(that).closest(".Table").find(".DynamicRow");
  Length = Element.length;
  for (var i = 0; i < Length; i++) {
    EvenColumnCounter = 0;
    OddColumnCounter = 0;
    DataType = Element.eq(i).find(".Column").eq(4).find(":text").eq(0).val();
    if (DataType == "Short" || DataType == "Unsigned Short")
      BitTotalNumber = 16;
    else if (DataType == "Long" || DataType == "Unsigned Long")
      BitTotalNumber = 32;
    for (var j = 0; j < BitTotalNumber; j++) {
      if (j % 2 == 0) {
        // Even Column
        BitVariable = Element.eq(i)
          .find(".Column")
          .eq(1)
          .find(".Row_2")
          .find(":text")
          .eq(EvenColumnCounter + 1)
          .val();
        EvenColumnCounter = EvenColumnCounter + 2;
      } else if (j % 2 == 1) {
        // Odd Column
        BitVariable = Element.eq(i)
          .find(".Column")
          .eq(2)
          .find(".Row_2")
          .find(":text")
          .eq(OddColumnCounter + 1)
          .val();
        OddColumnCounter = OddColumnCounter + 2;
      }
      if (BitVariable != null && BitVariable != "") {
        Return[0].push(BitVariable);
        Return[1].push(i);
      }
    }
  }
  return Return;
};

TcpModuleSecondPage.prototype._GetBitwiseTableVariableValue_ = function (that) {
  var AllName;
  AllName = TcpModuleSecondPage.prototype._GetBitwiseUIValue_(that);
  //AllName[0] = AllName[0].sort(function (a, b) {return a - b});

  return AllName;
};

TcpModuleSecondPage.prototype._IsNameFormat_ = function (Name) {
  var Return = true,
    Class = new Type();
  if (
    Class.CheckChineseLanguage(Name) == true ||
    Class.CheckSpecialSymbols(Name) == true ||
    Name == ""
  ) {
    Return = false;
  }
  return Return;
};

TcpModuleSecondPage.prototype._IsNameRepeat_ = function (AllName, Name) {
  var Return = false,
    Index = 1;
  for (var i = 0; i <= AllName.length; i++) {
    if (Index > 2) {
      Return = true;
      break;
    }
    if (Name == AllName[i] && Name != "") {
      Index++;
    }
  }
  return Return;
};

TcpModuleSecondPage.prototype._ArrayInteraction_ = function (
  FirstArray,
  SecondArray
) {
  var Return = new Array();
  for (var i = 0; i < FirstArray.length; i++) {
    if (SecondArray.indexOf(FirstArray[i]) != -1) {
      Return.push(FirstArray[i]);
    }
  }
  return Return;
};

TcpModuleSecondPage.prototype._ArrayComplement_ = function (
  FirstArray,
  SecondArray
) {
  var Return = new Array();
  for (var i = 0; i < FirstArray.length; i++) {
    if (SecondArray.indexOf(FirstArray[i]) == -1) {
      Return.push(FirstArray[i]);
    }
  }
  return Return;
};

TcpModuleSecondPage.prototype._ClearForm_ = function () {
  $("#SettingForm").find(".Row").eq(0).find(".Select").val("CoilStatus");
  $("#SettingForm").find(".Row").eq(1).find(".Text").val(0);
  $("#SettingForm").find(".Row").eq(2).find(".Text").val(1);
  $("#SettingForm").find(".Row").eq(3).find(".Select").val("Short");
  $("#SettingForm").find(".Row").eq(3).hide();
  $("#SettingForm").find(".Message").hide();
};

TcpModuleSecondPage.prototype._ClearDataModelTable_ = function () {
  var array = new Array(
    "InputRegistersTable",
    "HoldingRegistersTable",
    "InputStatusTable",
    "CoilStatusTable"
  );
  for (var i = 0; i < array.length; i++) {
    $("#" + array[i])
      .find(".DynamicRow")
      .remove();
  }
};

TcpModuleSecondPage.prototype._ClearTotalTable_ = function () {
  var array = new Array(
    "CoilStatusTotalTable",
    "InputStatusTotalTable",
    "HoldingRegistersTotalTable",
    "InputRegistersTotalTable"
  );
  for (var i = 0; i < array.length; i++) {
    $("#" + array[i])
      .find(".DynamicRow")
      .remove();
  }
};

TcpModuleSecondPage.prototype._ClearScalingTable_ = function () {
  var array = new Array(
    "ScalingHoldingRegistersTable",
    "ScalingInputRegistersTable"
  );
  for (var i = 0; i < array.length; i++) {
    $("#" + array[i])
      .find(".DynamicRow")
      .remove();
  }
};

TcpModuleSecondPage.prototype._ClearBitwiseTable_ = function () {
  var array = new Array(
    "BitwiseHoldingRegistersTable",
    "BitwiseInputRegistersTable"
  );
  for (var i = 0; i < array.length; i++) {
    $("#" + array[i])
      .find(".DynamicRow")
      .remove();
  }
};

TcpModuleSecondPage.prototype._ConvertedIntoTotalTableUiData_ = function (
  Data
) {
  var Temp = new Array(),
    StartAddress,
    DataCount,
    Return = new Object();
  var Address = Object.keys(Data);
  for (var i = 0; i < Address.length; i++) {
    Temp.push(parseInt(Address[i]));
    if (
      i == Address.length - 1 ||
      Data[Address[i]]["ModbusGroupNumber"] !=
        Data[Address[i + 1]]["ModbusGroupNumber"]
    ) {
      StartAddress = Math.min.apply(Math, Temp);
      DataCount = Temp.length;
      DataType = Data[Address[i]]["DataType"];
      Return = TcpModuleSecondPage.prototype._AddTotalTableData_(
        StartAddress,
        DataCount,
        DataType,
        Return
      );
      Temp = new Array();
    }
  }
  return Return;
};

TcpModuleSecondPage.prototype._GetTotalTableNeedData_ = function (number) {
  var Return = new Object();
  Return["CoilStatus"] = new Object();
  Return["InputStatus"] = new Object();
  Return["HoldingRegisters"] = new Object();
  Return["InputRegisters"] = new Object();
  var SystemVariable = Object.keys(Global_TcpVariable[number]);
  var object, Model, Address, DataType;
  for (var i = 0; i < SystemVariable.length; i++) {
    Address = parseInt(
      Global_TcpVariable[number][SystemVariable[i]]["Address"]
    );
    object = new Object();
    object[Address] = new Object();
    object[Address]["DataType"] = SystemVariable[i].split("-")[1];
    object[Address]["ModbusGroupNumber"] = parseInt(
      Global_TcpVariable[number][SystemVariable[i]]["ModbusGroupNumber"]
    );

    if (SystemVariable[i].split("-")[0] == "DO") {
      Model = "CoilStatus";
    } else if (SystemVariable[i].split("-")[0] == "DI") {
      Model = "InputStatus";
    } else if (SystemVariable[i].split("-")[0] == "AO") {
      Model = "HoldingRegisters";
    } else if (SystemVariable[i].split("-")[0] == "AI") {
      Model = "InputRegisters";
    }
    Return[Model][Address] = new Object();
    Return[Model][Address] = object[Address];
  }
  return Return;
};

TcpModuleSecondPage.prototype._GetDataModelTableUiData_ = function (number) {
  var DataModel = new Object();
  DataModel["CoilStatus"] = new Object();
  DataModel["InputStatus"] = new Object();
  DataModel["HoldingRegisters"] = new Object();
  DataModel["InputRegisters"] = new Object();
  var Model,
    object,
    SystemVariable = Object.keys(Global_TcpVariable[number]);
  for (var i = 0; i < SystemVariable.length; i++) {
    var Address = parseInt(
      Global_TcpVariable[number][SystemVariable[i]]["Address"]
    );
    object = new Object();
    object[Address] = new Object();
    object[Address]["VariableName"] =
      Global_TcpVariable[number][SystemVariable[i]]["VariableName"];
    object[Address]["DataType"] = SystemVariable[i].split("-")[1];
    object[Address]["Swap"] =
      Global_TcpVariable[number][SystemVariable[i]]["Swap"];
    object[Address]["Description"] =
      Global_TcpVariable[number][SystemVariable[i]]["Description"];

    if (SystemVariable[i].split("-")[0] == "DO") {
      Model = "CoilStatus";
    } else if (SystemVariable[i].split("-")[0] == "DI") {
      Model = "InputStatus";
    } else if (SystemVariable[i].split("-")[0] == "AO") {
      Model = "HoldingRegisters";
    } else if (SystemVariable[i].split("-")[0] == "AI") {
      Model = "InputRegisters";
    }
    DataModel[Model][Address] = new Object();
    DataModel[Model][Address] = object[Address];
  }
  return DataModel;
};

TcpModuleSecondPage.prototype._GetScalingTableUiData_ = function (number) {
  var DataModel = new Object();
  DataModel["HoldingRegisters"] = new Object();
  DataModel["InputRegisters"] = new Object();
  var Model, object, SystemVariable;
  if (typeof Global_TcpScalingVariable[number] != "object") {
    return DataModel;
  } else {
    SystemVariable = Object.keys(Global_TcpScalingVariable[number]);
  }
  for (var i = 0; i < SystemVariable.length; i++) {
    var Address = parseInt(
      Global_TcpScalingVariable[number][SystemVariable[i]]["Address"]
    );
    object = new Object();
    object[Address] = new Object();
    object[Address]["VariableName"] =
      Global_TcpScalingVariable[number][SystemVariable[i]]["VariableName"];
    object[Address]["InputDataMin"] =
      Global_TcpScalingVariable[number][SystemVariable[i]]["InputDataMin"];
    object[Address]["InputDataMax"] =
      Global_TcpScalingVariable[number][SystemVariable[i]]["InputDataMax"];
    object[Address]["ScaleVariableName"] =
      Global_TcpScalingVariable[number][SystemVariable[i]]["ScaleVariableName"];
    object[Address]["OutputDataMin"] =
      Global_TcpScalingVariable[number][SystemVariable[i]]["OutputDataMin"];
    object[Address]["OutputDataMax"] =
      Global_TcpScalingVariable[number][SystemVariable[i]]["OutputDataMax"];
    object[Address]["Offset"] =
      Global_TcpScalingVariable[number][SystemVariable[i]]["Offset"];
    object[Address]["TransformScaling"] =
      Global_TcpScalingVariable[number][SystemVariable[i]]["TransformScaling"];
    object[Address]["Description"] =
      Global_TcpScalingVariable[number][SystemVariable[i]]["Description"];
    object[Address]["DataType"] =
      Global_TcpScalingVariable[number][SystemVariable[i]]["DataType"];

    if (SystemVariable[i].split("-")[0] == "AO") {
      Model = "HoldingRegisters";
    } else if (SystemVariable[i].split("-")[0] == "AI") {
      Model = "InputRegisters";
    }
    DataModel[Model][Address] = new Object();
    DataModel[Model][Address] = object[Address];
  }
  return DataModel;
};

TcpModuleSecondPage.prototype._GetBitwiseVariableFromGlobal_ = function (
  object,
  Data
) {
  var BitNameId = "";
  var BitTotalNumber = 0;
  if (Data["DataType"] == "Short" || Data["DataType"] == "Unsigned Short")
    BitTotalNumber = 16;
  else if (Data["DataType"] == "Long" || Data["DataType"] == "Unsigned Long")
    BitTotalNumber = 32;
  for (var i = 0; i < BitTotalNumber; i++) {
    BitNameId = "BitTagName-" + i.toString();
    if (Data[BitNameId] != null && Data[BitNameId] != "") {
      object[BitNameId] = Data[BitNameId];
    }
  }
};

TcpModuleSecondPage.prototype._GetBitwiseTableUiData_ = function (number) {
  var DataModel = new Object();
  DataModel["HoldingRegisters"] = new Object();
  DataModel["InputRegisters"] = new Object();
  var Model, object, SystemVariable;
  if (typeof Global_TcpBitwiseVariable[number] != "object") {
    return DataModel;
  } else {
    SystemVariable = Object.keys(Global_TcpBitwiseVariable[number]);
  }
  for (var i = 0; i < SystemVariable.length; i++) {
    var Address = parseInt(
      Global_TcpBitwiseVariable[number][SystemVariable[i]]["Address"]
    );
    object = new Object();
    object[Address] = new Object();
    object[Address]["VariableName"] =
      Global_TcpBitwiseVariable[number][SystemVariable[i]]["VariableName"];
    object[Address]["Description"] =
      Global_TcpBitwiseVariable[number][SystemVariable[i]]["Description"];
    object[Address]["DataType"] =
      Global_TcpBitwiseVariable[number][SystemVariable[i]]["DataType"];
    TcpModuleSecondPage.prototype._GetBitwiseVariableFromGlobal_(
      object[Address],
      Global_TcpBitwiseVariable[number][SystemVariable[i]]
    );

    if (SystemVariable[i].split("-")[0] == "AO") {
      Model = "HoldingRegisters";
    } else if (SystemVariable[i].split("-")[0] == "AI") {
      Model = "InputRegisters";
    }
    DataModel[Model][Address] = new Object();
    DataModel[Model][Address] = object[Address];
  }
  return DataModel;
};

TcpModuleSecondPage.prototype._SetFormInitialValue_ = function (number) {
  var DeviceName = TcpModuleFirstPage.prototype._GetDeviceName_();
  var ContentSettings = $(".Form").eq(1).find(".Row");
  ContentSettings.eq(0).find(".Text").val(number);
  ContentSettings.eq(1)
    .find(".Text")
    .val(Global_TcpModule[DeviceName][number]["ModuleName"]);

  ContentSettings.eq(2)
    .find(".Text")
    .eq(0)
    .val(Global_TcpSetting[number]["IP"].split(".")[0]);
  ContentSettings.eq(2)
    .find(".Text")
    .eq(1)
    .val(Global_TcpSetting[number]["IP"].split(".")[1]);
  ContentSettings.eq(2)
    .find(".Text")
    .eq(2)
    .val(Global_TcpSetting[number]["IP"].split(".")[2]);
  ContentSettings.eq(2)
    .find(".Text")
    .eq(3)
    .val(Global_TcpSetting[number]["IP"].split(".")[3]);

  ContentSettings.eq(3).find(".Text").val(Global_TcpSetting[number]["Port"]);
  ContentSettings.eq(4).find(".Text").val(Global_TcpSetting[number]["SlaveId"]);
  ContentSettings.eq(5).find(".Text").val(Global_TcpSetting[number]["Timeout"]);
  ContentSettings.eq(6)
    .find(".Text")
    .val(Global_TcpSetting[number]["PollingRate"]);
};

TcpModuleSecondPage.prototype._SetDataModelTableInitialValue_ = function (
  number
) {
  var Data = TcpModuleSecondPage.prototype._GetDataModelTableUiData_(number);
  TcpModuleSecondPage.prototype._DataModelTableAddNewRow_(
    "CoilStatus",
    Data["CoilStatus"]
  );
  TcpModuleSecondPage.prototype._SetDataModelTableNewRowValue_(
    "CoilStatus",
    Data["CoilStatus"]
  );
  TcpModuleSecondPage.prototype._DataModelTableAddNewRow_(
    "InputStatus",
    Data["InputStatus"]
  );
  TcpModuleSecondPage.prototype._SetDataModelTableNewRowValue_(
    "InputStatus",
    Data["InputStatus"]
  );
  TcpModuleSecondPage.prototype._DataModelTableAddNewRow_(
    "HoldingRegisters",
    Data["HoldingRegisters"]
  );
  TcpModuleSecondPage.prototype._SetDataModelTableNewRowValue_(
    "HoldingRegisters",
    Data["HoldingRegisters"]
  );
  TcpModuleSecondPage.prototype._DataModelTableAddNewRow_(
    "InputRegisters",
    Data["InputRegisters"]
  );
  TcpModuleSecondPage.prototype._SetDataModelTableNewRowValue_(
    "InputRegisters",
    Data["InputRegisters"]
  );
};

TcpModuleSecondPage.prototype._SetScalingTableInitialValue_ = function (
  number
) {
  var Data = TcpModuleSecondPage.prototype._GetScalingTableUiData_(number);
  TcpModuleSecondPage.prototype._ScalingTableAddNewRow_(
    "HoldingRegisters",
    Data["HoldingRegisters"]
  );
  TcpModuleSecondPage.prototype._SetScalingTableNewRowValue_(
    "HoldingRegisters",
    Data["HoldingRegisters"]
  );
  TcpModuleSecondPage.prototype._ScalingTableAddNewRow_(
    "InputRegisters",
    Data["InputRegisters"]
  );
  TcpModuleSecondPage.prototype._SetScalingTableNewRowValue_(
    "InputRegisters",
    Data["InputRegisters"]
  );
};

TcpModuleSecondPage.prototype._SetBitwiseTableInitialValue_ = function (
  number
) {
  var Data = TcpModuleSecondPage.prototype._GetBitwiseTableUiData_(number);
  TcpModuleSecondPage.prototype._BitwiseTableAddNewRow_(
    "HoldingRegisters",
    Data["HoldingRegisters"]
  );
  TcpModuleSecondPage.prototype._SetBitwiseTableNewRowValue_(
    "HoldingRegisters",
    Data["HoldingRegisters"]
  );
  TcpModuleSecondPage.prototype._BitwiseTableAddNewRow_(
    "InputRegisters",
    Data["InputRegisters"]
  );
  TcpModuleSecondPage.prototype._SetBitwiseTableNewRowValue_(
    "InputRegisters",
    Data["InputRegisters"]
  );
};

TcpModuleSecondPage.prototype._SetTotalTableInitialValue_ = function (number) {
  var Data = TcpModuleSecondPage.prototype._GetTotalTableNeedData_(number);
  var data = TcpModuleSecondPage.prototype._ConvertedIntoTotalTableUiData_(
    Data["CoilStatus"]
  );
  TcpModuleSecondPage.prototype._TotalTableAddNewRow_("CoilStatus", data);
  TcpModuleSecondPage.prototype._SetTotalTableNewRowValue_("CoilStatus", data);

  data = TcpModuleSecondPage.prototype._ConvertedIntoTotalTableUiData_(
    Data["InputStatus"]
  );
  TcpModuleSecondPage.prototype._TotalTableAddNewRow_("InputStatus", data);
  TcpModuleSecondPage.prototype._SetTotalTableNewRowValue_("InputStatus", data);

  data = TcpModuleSecondPage.prototype._ConvertedIntoTotalTableUiData_(
    Data["HoldingRegisters"]
  );
  TcpModuleSecondPage.prototype._TotalTableAddNewRow_("HoldingRegisters", data);
  TcpModuleSecondPage.prototype._SetTotalTableNewRowValue_(
    "HoldingRegisters",
    data
  );

  data = TcpModuleSecondPage.prototype._ConvertedIntoTotalTableUiData_(
    Data["InputRegisters"]
  );
  TcpModuleSecondPage.prototype._TotalTableAddNewRow_("InputRegisters", data);
  TcpModuleSecondPage.prototype._SetTotalTableNewRowValue_(
    "InputRegisters",
    data
  );
};

TcpModuleSecondPage.prototype._SetInitialValue_ = function (number) {
  TcpModuleSecondPage.prototype._ClearForm_();
  TcpModuleSecondPage.prototype._ClearDataModelTable_();
  TcpModuleSecondPage.prototype._ClearTotalTable_();
  TcpModuleSecondPage.prototype._ClearScalingTable_();
  TcpModuleSecondPage.prototype._ClearBitwiseTable_();
  var ContentSettings = $(".Form").eq(1).find(".Row");
  ContentSettings.eq(0).find(".Text").val(number);
  if (typeof Global_TcpSetting[number] == "undefined") {
    ContentSettings.eq(1).find(".Text").val(number);
    return 0;
  }
  TcpModuleSecondPage.prototype._SetFormInitialValue_(number);
  if (typeof Global_TcpVariable[number] == "undefined") {
    return 0;
  }
  TcpModuleSecondPage.prototype._SetDataModelTableInitialValue_(number);
  TcpModuleSecondPage.prototype._SetTotalTableInitialValue_(number);
  TcpModuleSecondPage.prototype._SetScalingTableInitialValue_(number);
  TcpModuleSecondPage.prototype._SetBitwiseTableInitialValue_(number);
};

TcpModuleSecondPage.prototype._CreateVariableEmptyObject_ = function (number) {
  var Return = new Object();
  var object = jQuery.parseJSON(JSON.stringify(Global_TcpVariable[number]));
  var SystemVariable = Object.keys(object);
  for (var i = 0; i < SystemVariable.length; i++) {
    object[SystemVariable[i]] = null;
    delete object[SystemVariable[i]];
    object[SystemVariable[i]] = new Object();
  }
  Return[number] = new Object();
  Return[number] = object;
  return Return;
};

TcpModuleSecondPage.prototype._CreateScalingVariableEmptyObject_ = function (
  number
) {
  var Return = new Object();
  var object = jQuery.parseJSON(JSON.stringify(Global_TcpVariable[number]));
  var SystemVariable = Object.keys(object);
  for (var i = 0; i < SystemVariable.length; i++) {
    object[SystemVariable[i]] = null;
    delete object[SystemVariable[i]];
    object[SystemVariable[i]] = new Object();
  }
  Return[number] = new Object();
  Return[number] = object;
  return Return;
};

TcpModuleSecondPage.prototype._CreateBitwiseVariableEmptyObject_ = function (
  number
) {
  var Return = new Object();
  var object = jQuery.parseJSON(
    JSON.stringify(Global_TcpBitwiseVariable[number])
  );
  var SystemVariable = Object.keys(object);
  for (var i = 0; i < SystemVariable.length; i++) {
    object[SystemVariable[i]] = null;
    delete object[SystemVariable[i]];
    object[SystemVariable[i]] = new Object();
  }
  Return[number] = new Object();
  Return[number] = object;
  return Return;
};

TcpModuleSecondPage.prototype._InitialTcpToOpcuaEmptyObject_ = function (
  object,
  number
) {
  object = jQuery.parseJSON(JSON.stringify(object));
  var SystemVariable = Object.keys(object[number]);
  for (var i = 0; i < SystemVariable.length; i++) {
    object[number][SystemVariable[i]]["TransformOpcUa"] = false;
  }
  return object;
};

TcpModuleSecondPage.prototype._InitialTcpToScalingEmptyObject_ = function (
  object,
  number
) {
  object = jQuery.parseJSON(JSON.stringify(object));
  var SystemVariable = Object.keys(object[number]);
  for (var i = 0; i < SystemVariable.length; i++) {
    if (
      SystemVariable[i].split("-")[0] == "AO" ||
      SystemVariable[i].split("-")[0] == "AI"
    ) {
      object[number][SystemVariable[i]]["Address"] =
        SystemVariable[i].split("-")[2];
      object[number][SystemVariable[i]]["VariableName"] =
        Global_TcpVariable[number][SystemVariable[i]]["VariableName"];
      object[number][SystemVariable[i]]["InputDataMin"] = "0";
      object[number][SystemVariable[i]]["InputDataMax"] = "10";
      object[number][SystemVariable[i]]["ScaleVariableName"] =
        "Scale_" +
        Global_TcpVariable[number][SystemVariable[i]]["VariableName"];
      object[number][SystemVariable[i]]["OutputDataMin"] = 20;
      object[number][SystemVariable[i]]["OutputDataMax"] = 50;
      object[number][SystemVariable[i]]["Offset"] = 0;
      object[number][SystemVariable[i]]["TransformScaling"] = false;
      object[number][SystemVariable[i]]["Description"] = "";
      object[number][SystemVariable[i]]["DataType"] =
        SystemVariable[i].split("-")[1];
    } else {
      delete object[number][SystemVariable[i]];
    }
  }
  return object;
};

TcpModuleSecondPage.prototype._InitialTcpScalingToOpcuaEmptyObject_ = function (
  object,
  number
) {
  object = jQuery.parseJSON(JSON.stringify(object));
  var SystemVariable = Object.keys(object[number]);
  for (var i = 0; i < SystemVariable.length; i++) {
    if (
      SystemVariable[i].split("-")[0] == "AO" ||
      SystemVariable[i].split("-")[0] == "AI"
    ) {
      object[number][SystemVariable[i]]["TransformOpcUa"] = false;
    } else {
      delete object[number][SystemVariable[i]];
    }
  }
  return object;
};

TcpModuleSecondPage.prototype._InitialTcpBitwiseToOpcuaValue_ = function (
  object,
  Data
) {
  var BitNameId = "";
  var BitTotalNumber = 0;

  if (typeof Data["DataType"] == "undefined") {
    return 0;
  }

  if (Data["DataType"] == "Short" || Data["DataType"] == "Unsigned Short")
    BitTotalNumber = 16;
  else if (Data["DataType"] == "Long" || Data["DataType"] == "Unsigned Long")
    BitTotalNumber = 32;
  for (var i = 0; i < BitTotalNumber; i++) {
    BitNameId = "BitTagName-" + i.toString();
    if (Data[BitNameId] != null && Data[BitNameId] != "") {
      object[BitNameId] = false;
    }
  }
};

TcpModuleSecondPage.prototype._InitialTcpToBitwiseEmptyObject_ = function (
  object,
  number
) {
  object = jQuery.parseJSON(JSON.stringify(object));
  var SystemVariable = Object.keys(object[number]);
  for (var i = 0; i < SystemVariable.length; i++) {
    if (
      (SystemVariable[i].split("-")[0] == "AO" ||
        SystemVariable[i].split("-")[0] == "AI") &&
      SystemVariable[i].split("-")[1] != "Float" &&
      SystemVariable[i].split("-")[1] != "Double"
    ) {
      object[number][SystemVariable[i]]["Address"] =
        SystemVariable[i].split("-")[2];
      object[number][SystemVariable[i]]["VariableName"] =
        Global_TcpVariable[number][SystemVariable[i]]["VariableName"];
      object[number][SystemVariable[i]]["DataType"] =
        SystemVariable[i].split("-")[1];
      object[number][SystemVariable[i]]["Description"] = "";
    } else {
      delete object[number][SystemVariable[i]];
    }
  }
  return object;
};

TcpModuleSecondPage.prototype._InitialTcpBitwiseToOpcuaEmptyObject_ = function (
  object,
  number
) {
  object = jQuery.parseJSON(JSON.stringify(object));
  var SystemVariable = Object.keys(object[number]);
  for (var i = 0; i < SystemVariable.length; i++) {
    TcpModuleSecondPage.prototype._InitialTcpBitwiseToOpcuaValue_(
      object[number][SystemVariable[i]],
      Global_TcpBitwiseVariable[number][SystemVariable[i]]
    );
  }
  return object;
};

TcpModuleSecondPage.prototype._RetainTcpToOpcuaData_ = function (
  object,
  number
) {
  if (typeof Global_TcpToOpcuaVariable[number] != "object") {
    Global_TcpToOpcuaVariable[number] = new Object();
  }
  var NewSystemVariable = Object.keys(object[number]);
  var OldSystemVariable = Object.keys(Global_TcpToOpcuaVariable[number]);
  var SameVariable = TcpModuleSecondPage.prototype._ArrayInteraction_(
    NewSystemVariable,
    OldSystemVariable
  );
  for (var i = 0; i < SameVariable.length; i++) {
    object[number][SameVariable[i]] =
      Global_TcpToOpcuaVariable[number][SameVariable[i]];
  }
  Global_TcpToOpcuaVariable[number] = jQuery.parseJSON(
    JSON.stringify(object[number])
  );
};

TcpModuleSecondPage.prototype._RetainTcpToScalingData_ = function (
  object,
  number
) {
  if (typeof Global_TcpScalingVariable[number] != "object") {
    Global_TcpScalingVariable[number] = new Object();
  }
  var NewSystemVariable = Object.keys(object[number]);
  var OldSystemVariable = Object.keys(Global_TcpScalingVariable[number]);
  var SameVariable = TcpModuleSecondPage.prototype._ArrayInteraction_(
    NewSystemVariable,
    OldSystemVariable
  );
  for (var i = 0; i < SameVariable.length; i++) {
    object[number][SameVariable[i]] =
      Global_TcpScalingVariable[number][SameVariable[i]];
  }
  Global_TcpScalingVariable[number] = jQuery.parseJSON(
    JSON.stringify(object[number])
  );
};

TcpModuleSecondPage.prototype._RetainTcpScalingToOpcuaData_ = function (
  object,
  number
) {
  if (typeof Global_TcpScalingToOpcuaVariable[number] != "object") {
    Global_TcpScalingToOpcuaVariable[number] = new Object();
  }
  var NewSystemVariable = Object.keys(object[number]);
  var OldSystemVariable = Object.keys(Global_TcpScalingToOpcuaVariable[number]);
  var SameVariable = TcpModuleSecondPage.prototype._ArrayInteraction_(
    NewSystemVariable,
    OldSystemVariable
  );
  for (var i = 0; i < SameVariable.length; i++) {
    object[number][SameVariable[i]] =
      Global_TcpScalingToOpcuaVariable[number][SameVariable[i]];
  }
  Global_TcpScalingToOpcuaVariable[number] = jQuery.parseJSON(
    JSON.stringify(object[number])
  );
};

TcpModuleSecondPage.prototype._RetainTcpToBitwiseData_ = function (
  object,
  number
) {
  if (typeof Global_TcpBitwiseVariable[number] != "object") {
    Global_TcpBitwiseVariable[number] = new Object();
  }
  var NewSystemVariable = Object.keys(object[number]);
  var OldSystemVariable = Object.keys(Global_TcpBitwiseVariable[number]);
  var SameVariable = TcpModuleSecondPage.prototype._ArrayInteraction_(
    NewSystemVariable,
    OldSystemVariable
  );
  for (var i = 0; i < SameVariable.length; i++) {
    object[number][SameVariable[i]] =
      Global_TcpBitwiseVariable[number][SameVariable[i]];
  }
  Global_TcpBitwiseVariable[number] = jQuery.parseJSON(
    JSON.stringify(object[number])
  );
};

TcpModuleSecondPage.prototype._UpdateTcpBitwiseToOpcuaVariable_ = function (
  number,
  SystemVariable
) {
  var BitNameId = "";
  var BitTotalNumber = 0;
  if (
    Global_TcpBitwiseVariable[number][SystemVariable]["DataType"] == "Short" ||
    Global_TcpBitwiseVariable[number][SystemVariable]["DataType"] ==
      "Unsigned Short"
  )
    BitTotalNumber = 16;
  else if (
    Global_TcpBitwiseVariable[number][SystemVariable]["DataType"] == "Long" ||
    Global_TcpBitwiseVariable[number][SystemVariable]["DataType"] ==
      "Unsigned Long"
  )
    BitTotalNumber = 32;
  for (var i = 0; i < BitTotalNumber; i++) {
    BitNameId = "BitTagName-" + i.toString();
    if (
      typeof Global_TcpBitwiseVariable[number][SystemVariable][BitNameId] ==
        "undefined" &&
      typeof Global_TcpBitwiseToOpcuaVariable[number][SystemVariable][
        BitNameId
      ] != "undefined"
    ) {
      Global_TcpBitwiseToOpcuaVariable[number][SystemVariable][BitNameId] =
        null;
      delete Global_TcpBitwiseToOpcuaVariable[number][SystemVariable][
        BitNameId
      ];
    } else if (
      typeof Global_TcpBitwiseVariable[number][SystemVariable][BitNameId] !=
        "undefined" &&
      typeof Global_TcpBitwiseToOpcuaVariable[number][SystemVariable][
        BitNameId
      ] == "undefined"
    ) {
      Global_TcpBitwiseToOpcuaVariable[number][SystemVariable][
        BitNameId
      ] = false;
    }
  }
  return Global_TcpBitwiseToOpcuaVariable[number][SystemVariable];
};

TcpModuleSecondPage.prototype._RetainTcpBitwiseToOpcuaData_ = function (
  object,
  number
) {
  if (typeof Global_TcpBitwiseToOpcuaVariable[number] != "object") {
    Global_TcpBitwiseToOpcuaVariable[number] = new Object();
  }
  var NewSystemVariable = Object.keys(object[number]);
  var OldSystemVariable = Object.keys(Global_TcpBitwiseToOpcuaVariable[number]);
  var SameVariable = TcpModuleSecondPage.prototype._ArrayInteraction_(
    NewSystemVariable,
    OldSystemVariable
  );
  for (var i = 0; i < SameVariable.length; i++) {
    object[number][SameVariable[i]] =
      TcpModuleSecondPage.prototype._UpdateTcpBitwiseToOpcuaVariable_(
        number,
        SameVariable[i]
      );
  }
  Global_TcpBitwiseToOpcuaVariable[number] = jQuery.parseJSON(
    JSON.stringify(object[number])
  );
};

TcpModuleSecondPage.prototype._InitialTcpToMqttVariableEmptyObject_ = function (
  object,
  number
) {
  var AllDeviceName =
    GetValue.prototype._GetModuleAllDeviceName_(Global_TcpModule);
  //var AllDeviceName=TcpModuleFirstPage.prototype._GetAllDeviceName_();
  for (var i = 0; i < AllDeviceName.length; i++) {
    if (typeof Global_TcpModule[AllDeviceName[i]][number] == "object") {
      var DeviceName = AllDeviceName[i];
      break;
    }
  }
  object = jQuery.parseJSON(JSON.stringify(object));
  var SystemVariable = Object.keys(object[number]);
  for (var i = 0; i < SystemVariable.length; i++) {
    var IO = SystemVariable[i].split("-")[0];
    var Variable =
      Global_TcpVariable[number][SystemVariable[i]]["VariableName"];
    var ModuleName = Global_TcpModule[DeviceName][number]["ModuleName"];
    if (IO == "DO" || IO == "AO") {
      object[number][SystemVariable[i]]["SubscribeTopic"] =
        "/MTCP_No." +
        number +
        "_" +
        ModuleName +
        "/" +
        TcpModuleSecondPage.prototype._GetDataModel_(IO) +
        "/" +
        Variable +
        "/Subscribe";
    }
    object[number][SystemVariable[i]]["PublishTopic"] =
      "/MTCP_No." +
      number +
      "_" +
      ModuleName +
      "/" +
      TcpModuleSecondPage.prototype._GetDataModel_(IO) +
      "/" +
      Variable +
      "/Publish";
    object[number][SystemVariable[i]]["SubscribeQos"] = 2;
    object[number][SystemVariable[i]]["PublishQos"] = 2;
    object[number][SystemVariable[i]]["Retain"] = false;
    object[number][SystemVariable[i]]["TransformMqtt"] = false;
  }
  return object;
};

TcpModuleSecondPage.prototype._RetainTcpToMqttVariableData_ = function (
  object,
  number
) {
  if (typeof Global_TcpToMqttVariable[number] != "object") {
    Global_TcpToMqttVariable[number] = new Object();
  }
  var NewSystemVariable = Object.keys(object[number]);
  var OldSystemVariable = Object.keys(Global_TcpToMqttVariable[number]);
  var SameVariable = TcpModuleSecondPage.prototype._ArrayInteraction_(
    NewSystemVariable,
    OldSystemVariable
  );
  for (var i = 0; i < SameVariable.length; i++) {
    object[number][SameVariable[i]] =
      Global_TcpToMqttVariable[number][SameVariable[i]];
  }
  Global_TcpToMqttVariable[number] = jQuery.parseJSON(
    JSON.stringify(object[number])
  );
};

TcpModuleSecondPage.prototype._InitialTcpToMqttJsonVariableEmptyObject_ =
  function (object, number) {
    var AllDeviceName =
      GetValue.prototype._GetModuleAllDeviceName_(Global_TcpModule);
    //var AllDeviceName=TcpModuleFirstPage.prototype._GetAllDeviceName_();
    for (var i = 0; i < AllDeviceName.length; i++) {
      if (typeof Global_TcpModule[AllDeviceName[i]][number] == "object") {
        var DeviceName = AllDeviceName[i];
        break;
      }
    }
    object = jQuery.parseJSON(JSON.stringify(object));
    var SystemVariable = Object.keys(object[number]);
    for (var i = 0; i < SystemVariable.length; i++) {
      object[number][SystemVariable[i]]["ConnectionGroup"] = "";
      object[number][SystemVariable[i]]["TransformMqttJson"] = false;
      object[number][SystemVariable[i]]["Alias"] =
        Global_TcpVariable[number][SystemVariable[i]]["VariableName"];
    }
    return object;
  };

TcpModuleSecondPage.prototype._RetainTcpToMqttJsonVariableData_ = function (
  object,
  number
) {
  if (typeof Global_TcpToMqttJsonVariable[number] != "object") {
    Global_TcpToMqttJsonVariable[number] = new Object();
  }
  var NewSystemVariable = Object.keys(object[number]);
  var OldSystemVariable = Object.keys(Global_TcpToMqttJsonVariable[number]);
  var SameVariable = TcpModuleSecondPage.prototype._ArrayInteraction_(
    NewSystemVariable,
    OldSystemVariable
  );
  for (var i = 0; i < SameVariable.length; i++) {
    object[number][SameVariable[i]] =
      Global_TcpToMqttJsonVariable[number][SameVariable[i]];
  }
  Global_TcpToMqttJsonVariable[number] = jQuery.parseJSON(
    JSON.stringify(object[number])
  );
};

TcpModuleSecondPage.prototype._InitialTcpToMsSqlVariableEmptyObject_ =
  function (object, number) {
    var AllDeviceName = TcpModuleFirstPage.prototype._GetAllDeviceName_();
    for (var i = 0; i < AllDeviceName.length; i++) {
      if (typeof Global_TcpModule[AllDeviceName[i]][number] == "object") {
        var DeviceName = AllDeviceName[i];
        break;
      }
    }
    object = jQuery.parseJSON(JSON.stringify(object));
    var SystemVariable = Object.keys(object[number]);
    for (var i = 0; i < SystemVariable.length; i++) {
      object[number][SystemVariable[i]]["DatabaseIndex"] = "";
      object[number][SystemVariable[i]]["DatabaseType"] = "Remote";
      object[number][SystemVariable[i]]["DatabaseRecord"] = false;
    }
    return object;
  };

TcpModuleSecondPage.prototype._RetainTcpToMsSqlVariableData_ = function (
  object,
  number
) {
  if (typeof Global_TcpToMsSqlVariable[number] != "object") {
    Global_TcpToMsSqlVariable[number] = new Object();
  }
  var NewSystemVariable = Object.keys(object[number]);
  var OldSystemVariable = Object.keys(Global_TcpToMsSqlVariable[number]);
  var SameVariable = TcpModuleSecondPage.prototype._ArrayInteraction_(
    NewSystemVariable,
    OldSystemVariable
  );
  for (var i = 0; i < SameVariable.length; i++) {
    object[number][SameVariable[i]] =
      Global_TcpToMsSqlVariable[number][SameVariable[i]];
  }
  Global_TcpToMsSqlVariable[number] = jQuery.parseJSON(
    JSON.stringify(object[number])
  );
};

TcpModuleSecondPage.prototype._InitialTcpToMysqlConnectionVariableEmptyObject_ =
  function (object, number) {
    var AllDeviceName = TcpModuleFirstPage.prototype._GetAllDeviceName_();
    for (var i = 0; i < AllDeviceName.length; i++) {
      if (typeof Global_TcpModule[AllDeviceName[i]][number] == "object") {
        var DeviceName = AllDeviceName[i];
        break;
      }
    }
    object = jQuery.parseJSON(JSON.stringify(object));
    var SystemVariable = Object.keys(object[number]);
    for (var i = 0; i < SystemVariable.length; i++) {
      object[number][SystemVariable[i]]["DatabaseIndex"] = "";
      object[number][SystemVariable[i]]["DatabaseType"] = "Remote";
      object[number][SystemVariable[i]]["DatabaseRecord"] = false;
    }
    return object;
  };

TcpModuleSecondPage.prototype._RetainTcpToMysqlConnectionVariableData_ =
  function (object, number) {
    if (typeof Global_TcpToMysqlConnectionVariable[number] != "object") {
      Global_TcpToMysqlConnectionVariable[number] = new Object();
    }
    var NewSystemVariable = Object.keys(object[number]);
    var OldSystemVariable = Object.keys(
      Global_TcpToMysqlConnectionVariable[number]
    );
    var SameVariable = TcpModuleSecondPage.prototype._ArrayInteraction_(
      NewSystemVariable,
      OldSystemVariable
    );
    for (var i = 0; i < SameVariable.length; i++) {
      object[number][SameVariable[i]] =
        Global_TcpToMysqlConnectionVariable[number][SameVariable[i]];
    }
    Global_TcpToMysqlConnectionVariable[number] = jQuery.parseJSON(
      JSON.stringify(object[number])
    );
  };

TcpModuleSecondPage.prototype._InitialTcpToLocalDataLoggerVariableEmptyObject_ =
  function (object, number) {
    var AllDeviceName = TcpModuleFirstPage.prototype._GetAllDeviceName_();
    for (var i = 0; i < AllDeviceName.length; i++) {
      if (typeof Global_TcpModule[AllDeviceName[i]][number] == "object") {
        var DeviceName = AllDeviceName[i];
        break;
      }
    }
    object = jQuery.parseJSON(JSON.stringify(object));
    var SystemVariable = Object.keys(object[number]);
    for (var i = 0; i < SystemVariable.length; i++) {
      object[number][SystemVariable[i]]["LocalDataLoggerRecord"] = false;
    }
    return object;
  };

TcpModuleSecondPage.prototype._RetainTcpToLocalDataLoggerVariableData_ =
  function (object, number) {
    if (typeof Global_TcpToLocalDataLoggerVariable[number] != "object") {
      Global_TcpToLocalDataLoggerVariable[number] = new Object();
    }
    var NewSystemVariable = Object.keys(object[number]);
    var OldSystemVariable = Object.keys(
      Global_TcpToLocalDataLoggerVariable[number]
    );
    var SameVariable = TcpModuleSecondPage.prototype._ArrayInteraction_(
      NewSystemVariable,
      OldSystemVariable
    );
    for (var i = 0; i < SameVariable.length; i++) {
      object[number][SameVariable[i]] =
        Global_TcpToLocalDataLoggerVariable[number][SameVariable[i]];
    }
    Global_TcpToLocalDataLoggerVariable[number] = jQuery.parseJSON(
      JSON.stringify(object[number])
    );
  };

TcpModuleSecondPage.prototype._SynchronizeOtherServiceData_ = function (
  number
) {
  if (typeof Global_TcpVariable[number] != "object") {
    return 0;
  }
  var OldObject = jQuery.parseJSON(JSON.stringify(Global_TcpToOpcuaVariable));
  var object =
    TcpModuleSecondPage.prototype._CreateVariableEmptyObject_(number);
  var TcpToOpcua = TcpModuleSecondPage.prototype._InitialTcpToOpcuaEmptyObject_(
    object,
    number
  );
  TcpModuleSecondPage.prototype._RetainTcpToOpcuaData_(TcpToOpcua, number);

  var TcpToMqtt =
    TcpModuleSecondPage.prototype._InitialTcpToMqttVariableEmptyObject_(
      object,
      number
    );
  TcpModuleSecondPage.prototype._RetainTcpToMqttVariableData_(
    TcpToMqtt,
    number
  );

  var TcpToMqttJson =
    TcpModuleSecondPage.prototype._InitialTcpToMqttJsonVariableEmptyObject_(
      object,
      number
    );
  TcpModuleSecondPage.prototype._RetainTcpToMqttJsonVariableData_(
    TcpToMqttJson,
    number
  );

  var TcpToMsSqlVariable =
    TcpModuleSecondPage.prototype._InitialTcpToMsSqlVariableEmptyObject_(
      object,
      number
    );
  TcpModuleSecondPage.prototype._RetainTcpToMsSqlVariableData_(
    TcpToMsSqlVariable,
    number
  );
  var TcpToMysqlConnectionVariable =
    TcpModuleSecondPage.prototype._InitialTcpToMysqlConnectionVariableEmptyObject_(
      object,
      number
    );
  TcpModuleSecondPage.prototype._RetainTcpToMysqlConnectionVariableData_(
    TcpToMysqlConnectionVariable,
    number
  );

  var TcpToLocalDataLoggerVariable =
    TcpModuleSecondPage.prototype._InitialTcpToLocalDataLoggerVariableEmptyObject_(
      object,
      number
    );
  TcpModuleSecondPage.prototype._RetainTcpToLocalDataLoggerVariableData_(
    TcpToLocalDataLoggerVariable,
    number
  );

  TcpModuleSecondPage.prototype._SynchronizeTcpToScalingData_(object, number);
  TcpModuleSecondPage.prototype._SynchronizeTcpScalingToOpcuaData_(
    object,
    number
  );

  TcpModuleSecondPage.prototype._SynchronizeTcpToBitwiseData_(object, number);
  object = TcpModuleSecondPage.prototype._InitialTcpToBitwiseEmptyObject_(
    object,
    number
  );
  TcpModuleSecondPage.prototype._SynchronizeTcpBitwiseToOpcuaData_(
    object,
    number
  );

  var Class = new SynchronizeService();
  Class.ChangeVariableSynchronizationService("MTCP", OldObject, object, number);
  Class = null;
};

TcpModuleSecondPage.prototype._SynchronizeOtherServiceScalingData_ = function (
  number
) {
  if (typeof Global_TcpScalingVariable[number] != "object") {
    return 0;
  }
  var object =
    TcpModuleSecondPage.prototype._CreateScalingVariableEmptyObject_(number);
  TcpModuleSecondPage.prototype._SynchronizeTcpScalingToOpcuaData_(
    object,
    number
  );
};

TcpModuleSecondPage.prototype._SynchronizeTcpToScalingData_ = function (
  object,
  number
) {
  var TcpToScaling =
    TcpModuleSecondPage.prototype._InitialTcpToScalingEmptyObject_(
      object,
      number
    );
  TcpModuleSecondPage.prototype._RetainTcpToScalingData_(TcpToScaling, number);
};

TcpModuleSecondPage.prototype._SynchronizeTcpScalingToOpcuaData_ = function (
  object,
  number
) {
  var TcpScalingToOpcua =
    TcpModuleSecondPage.prototype._InitialTcpScalingToOpcuaEmptyObject_(
      object,
      number
    );
  TcpModuleSecondPage.prototype._RetainTcpScalingToOpcuaData_(
    TcpScalingToOpcua,
    number
  );
};

TcpModuleSecondPage.prototype._SynchronizeOtherServiceBitwiseData_ = function (
  number
) {
  if (typeof Global_TcpBitwiseVariable[number] != "object") {
    return 0;
  }
  var object =
    TcpModuleSecondPage.prototype._CreateBitwiseVariableEmptyObject_(number);
  TcpModuleSecondPage.prototype._SynchronizeTcpBitwiseToOpcuaData_(
    object,
    number
  );
};

TcpModuleSecondPage.prototype._SynchronizeTcpToBitwiseData_ = function (
  object,
  number
) {
  var TcpToBitwise =
    TcpModuleSecondPage.prototype._InitialTcpToBitwiseEmptyObject_(
      object,
      number
    );
  TcpModuleSecondPage.prototype._RetainTcpToBitwiseData_(TcpToBitwise, number);
};

TcpModuleSecondPage.prototype._SynchronizeTcpBitwiseToOpcuaData_ = function (
  object,
  number
) {
  var TcpBitwiseToOpcua =
    TcpModuleSecondPage.prototype._InitialTcpBitwiseToOpcuaEmptyObject_(
      object,
      number
    );
  TcpModuleSecondPage.prototype._RetainTcpBitwiseToOpcuaData_(
    TcpBitwiseToOpcua,
    number
  );
};

TcpModuleSecondPage.prototype._ReplaceScalingBitwiseSourceVariableName_ =
  function (DataModel, TargetAddress, ReplaceName) {
    var length = $("#" + DataModel).find(".DynamicRow").length;
    for (var i = 0; i < length; i++) {
      var CurrentAddress = parseInt(
        $("#" + DataModel)
          .find(".DynamicRow")
          .eq(i)
          .find(".Column")
          .eq(0)
          .text()
      );
      if (TargetAddress == CurrentAddress) {
        $("#" + DataModel)
          .find(".DynamicRow")
          .eq(i)
          .find(".Column")
          .eq(1)
          .find(".Text")
          .eq(0)
          .val(ReplaceName);
        break;
      }
    }
  };

TcpModuleSecondPage.prototype._SynchronizeScalingBitwiseSourceVariableName_ =
  function (Mode) {
    var DataModel = "HoldingRegisters";
    var TargetDataModel = Mode + DataModel + "Table";
    var element = $("#" + DataModel + "Table").find(".DynamicRow");

    for (var i = 0; i < element.length; i++) {
      var Address = parseInt(element.eq(i).find(".Column").eq(0).text());
      var ReplaceName = element.eq(i).find(".Text").val();
      TcpModuleSecondPage.prototype._ReplaceScalingBitwiseSourceVariableName_(
        TargetDataModel,
        Address,
        ReplaceName
      );
    }

    DataModel = "InputRegisters";
    TargetDataModel = Mode + DataModel + "Table";
    element = $("#" + DataModel + "Table").find(".DynamicRow");

    for (var i = 0; i < element.length; i++) {
      var Address = parseInt(element.eq(i).find(".Column").eq(0).text());
      var ReplaceName = element.eq(i).find(".Text").val();
      TcpModuleSecondPage.prototype._ReplaceScalingBitwiseSourceVariableName_(
        TargetDataModel,
        Address,
        ReplaceName
      );
    }
  };

TcpModuleSecondPage.prototype._BuildTcpSettingObject_ = function (number) {
  var ContentSettings = $(".Form").eq(1).find(".Row");
  var IP =
    ContentSettings.eq(2).find(".Text").eq(0).val() +
    "." +
    ContentSettings.eq(2).find(".Text").eq(1).val() +
    "." +
    ContentSettings.eq(2).find(".Text").eq(2).val() +
    "." +
    ContentSettings.eq(2).find(".Text").eq(3).val();
  var Port = ContentSettings.eq(3).find(".Text").val();
  var SlaveId = parseInt(ContentSettings.eq(4).find(".Text").val());
  var Timeout = parseInt(ContentSettings.eq(5).find(".Text").val());
  var PollingRate = parseInt(ContentSettings.eq(6).find(".Text").val());
  if (typeof Global_TcpSetting[number] == "undefined") {
    Global_TcpSetting[number] = new Object();
  }
  Global_TcpSetting[number]["IP"] = IP;
  Global_TcpSetting[number]["Port"] = Port;
  Global_TcpSetting[number]["SlaveId"] = SlaveId;
  Global_TcpSetting[number]["Timeout"] = Timeout;
  Global_TcpSetting[number]["PollingRate"] = PollingRate;
};

TcpModuleSecondPage.prototype._BuildNewSystemVariableName_ = function (
  DataModelId,
  Data
) {
  var Prefix,
    SystemVariableName,
    NewSystemVariableName = new Array();
  if (DataModelId == "CoilStatus") {
    Prefix = "DO";
  } else if (DataModelId == "InputStatus") {
    Prefix = "DI";
  } else if (DataModelId == "HoldingRegisters") {
    Prefix = "AO";
  } else if (DataModelId == "InputRegisters") {
    Prefix = "AI";
  }
  var ObjKey = Object.keys(Data);
  for (var j = 0; j < ObjKey.length; j++) {
    SystemVariableName =
      Prefix + "-" + Data[ObjKey[j]]["DataType"] + "-" + ObjKey[j];
    NewSystemVariableName.push(SystemVariableName);
  }
  return NewSystemVariableName;
};

TcpModuleSecondPage.prototype._SetNewTcpVariableObjectValue_ = function (
  DataModelId,
  Data,
  number
) {
  var Prefix, SystemVariableName;
  if (DataModelId == "CoilStatus") {
    Prefix = "DO";
  } else if (DataModelId == "InputStatus") {
    Prefix = "DI";
  } else if (DataModelId == "HoldingRegisters") {
    Prefix = "AO";
  } else if (DataModelId == "InputRegisters") {
    Prefix = "AI";
  }
  var ObjKey = Object.keys(Data);
  for (var j = 0; j < ObjKey.length; j++) {
    SystemVariableName =
      Prefix + "-" + Data[ObjKey[j]]["DataType"] + "-" + ObjKey[j];
    if (typeof Global_TcpVariable[number][SystemVariableName] == "undefined") {
      Global_TcpVariable[number][SystemVariableName] = new Object();
    }
    Global_TcpVariable[number][SystemVariableName]["ModbusGroupNumber"] =
      TcpModuleSecondPage.prototype._GetGroupNumber_(DataModelId, ObjKey[j]);
    Global_TcpVariable[number][SystemVariableName]["Address"] = parseInt(
      ObjKey[j]
    );
    Global_TcpVariable[number][SystemVariableName]["VariableName"] =
      Data[ObjKey[j]]["VariableName"];
    Global_TcpVariable[number][SystemVariableName]["Swap"] =
      Data[ObjKey[j]]["Swap"];
    Global_TcpVariable[number][SystemVariableName]["Description"] =
      Data[ObjKey[j]]["Description"];
  }
};

TcpModuleSecondPage.prototype._SetNewTcpScalingVariableObjectValue_ = function (
  DataModelId,
  Data,
  number
) {
  var Prefix, SystemVariableName;
  if (DataModelId == "HoldingRegisters") {
    Prefix = "AO";
  } else if (DataModelId == "InputRegisters") {
    Prefix = "AI";
  }
  var ObjKey = Object.keys(Data);
  for (var j = 0; j < ObjKey.length; j++) {
    SystemVariableName =
      Prefix + "-" + Data[ObjKey[j]]["DataType"] + "-" + ObjKey[j];
    if (
      typeof Global_TcpScalingVariable[number][SystemVariableName] ==
      "undefined"
    ) {
      Global_TcpScalingVariable[number][SystemVariableName] = new Object();
    }
    Global_TcpScalingVariable[number][SystemVariableName]["Address"] = parseInt(
      ObjKey[j]
    );
    Global_TcpScalingVariable[number][SystemVariableName]["VariableName"] =
      Data[ObjKey[j]]["VariableName"];
    Global_TcpScalingVariable[number][SystemVariableName]["InputDataMin"] =
      Data[ObjKey[j]]["InputDataMin"];
    Global_TcpScalingVariable[number][SystemVariableName]["InputDataMax"] =
      Data[ObjKey[j]]["InputDataMax"];
    Global_TcpScalingVariable[number][SystemVariableName]["ScaleVariableName"] =
      Data[ObjKey[j]]["ScaleVariableName"];
    Global_TcpScalingVariable[number][SystemVariableName]["OutputDataMin"] =
      Data[ObjKey[j]]["OutputDataMin"];
    Global_TcpScalingVariable[number][SystemVariableName]["OutputDataMax"] =
      Data[ObjKey[j]]["OutputDataMax"];
    Global_TcpScalingVariable[number][SystemVariableName]["Offset"] =
      Data[ObjKey[j]]["Offset"];
    Global_TcpScalingVariable[number][SystemVariableName]["TransformScaling"] =
      Data[ObjKey[j]]["TransformScaling"];
    Global_TcpScalingVariable[number][SystemVariableName]["Description"] =
      Data[ObjKey[j]]["Description"];
    Global_TcpScalingVariable[number][SystemVariableName]["DataType"] =
      Data[ObjKey[j]]["DataType"];
  }
};

TcpModuleSecondPage.prototype._SetNewTcpBitwiseTagObjectValue_ = function (
  GlboalVariable,
  Data
) {
  var BitNameId = "";
  var BitTotalNumber = 0;
  if (Data["DataType"] == "Short" || Data["DataType"] == "Unsigned Short")
    BitTotalNumber = 16;
  else if (Data["DataType"] == "Long" || Data["DataType"] == "Unsigned Long")
    BitTotalNumber = 32;
  for (var i = 0; i < BitTotalNumber; i++) {
    BitNameId = "BitTagName-" + i.toString();
    if (
      typeof GlboalVariable[BitNameId] != "undefined" &&
      typeof Data[BitNameId] != "undefined"
    ) {
      GlboalVariable[BitNameId] = Data[BitNameId];
    } else if (
      typeof GlboalVariable[BitNameId] == "undefined" &&
      typeof Data[BitNameId] != "undefined"
    ) {
      GlboalVariable[BitNameId] = Data[BitNameId];
    } else {
      delete GlboalVariable[BitNameId];
    }
  }
};

TcpModuleSecondPage.prototype._SetNewTcpBitwiseVariableObjectValue_ = function (
  DataModelId,
  Data,
  number
) {
  var Prefix, SystemVariableName;
  if (DataModelId == "HoldingRegisters") {
    Prefix = "AO";
  } else if (DataModelId == "InputRegisters") {
    Prefix = "AI";
  }
  var ObjKey = Object.keys(Data);
  for (var j = 0; j < ObjKey.length; j++) {
    SystemVariableName =
      Prefix + "-" + Data[ObjKey[j]]["DataType"] + "-" + ObjKey[j];
    if (
      typeof Global_TcpBitwiseVariable[number][SystemVariableName] ==
      "undefined"
    ) {
      Global_TcpBitwiseVariable[number][SystemVariableName] = new Object();
    }
    Global_TcpBitwiseVariable[number][SystemVariableName]["Address"] = parseInt(
      ObjKey[j]
    );
    Global_TcpBitwiseVariable[number][SystemVariableName]["VariableName"] =
      Data[ObjKey[j]]["VariableName"];
    Global_TcpBitwiseVariable[number][SystemVariableName]["Description"] =
      Data[ObjKey[j]]["Description"];
    Global_TcpBitwiseVariable[number][SystemVariableName]["DataType"] =
      Data[ObjKey[j]]["DataType"];
    TcpModuleSecondPage.prototype._SetNewTcpBitwiseTagObjectValue_(
      Global_TcpBitwiseVariable[number][SystemVariableName],
      Data[ObjKey[j]]
    );
  }
};

TcpModuleSecondPage.prototype._BuildTcpVariableObject_ = function (number) {
  var OldSystemVariableName = new Array();

  if (typeof Global_TcpVariable[number] == "undefined") {
    Global_TcpVariable[number] = new Object();
  } else {
    OldSystemVariableName = Object.keys(Global_TcpVariable[number]);
  }

  var NewSystemVariableName = new Array(),
    Data = new Object();
  var DataModelId = new Array(
    "CoilStatus",
    "InputStatus",
    "HoldingRegisters",
    "InputRegisters"
  );
  for (var i = 0; i < DataModelId.length; i++) {
    Data = TcpModuleSecondPage.prototype._GetDataModelTableOldData_(
      DataModelId[i]
    );
    TcpModuleSecondPage.prototype._SetNewTcpVariableObjectValue_(
      DataModelId[i],
      Data,
      number
    );
    NewSystemVariableName = NewSystemVariableName.concat(
      TcpModuleSecondPage.prototype._BuildNewSystemVariableName_(
        DataModelId[i],
        Data
      )
    );
  }

  var array = TcpModuleSecondPage.prototype._ArrayComplement_(
    OldSystemVariableName,
    NewSystemVariableName
  );
  for (var i = 0; i < array.length; i++) {
    Global_TcpVariable[number][array[i]] = null;
    delete Global_TcpVariable[number][array[i]];
  }
};

TcpModuleSecondPage.prototype._BuildTcpScalingObject_ = function (number) {
  var OldSystemVariableName = new Array();

  if (typeof Global_TcpScalingVariable[number] == "undefined") {
    Global_TcpScalingVariable[number] = new Object();
  } else {
    OldSystemVariableName = Object.keys(Global_TcpScalingVariable[number]);
  }

  var NewSystemVariableName = new Array(),
    Data = new Object();
  var DataModelId = new Array("HoldingRegisters", "InputRegisters");
  for (var i = 0; i < DataModelId.length; i++) {
    Data = TcpModuleSecondPage.prototype._GetScalingTableOldData_(
      DataModelId[i]
    );
    TcpModuleSecondPage.prototype._SetNewTcpScalingVariableObjectValue_(
      DataModelId[i],
      Data,
      number
    );
    NewSystemVariableName = NewSystemVariableName.concat(
      TcpModuleSecondPage.prototype._BuildNewSystemVariableName_(
        DataModelId[i],
        Data
      )
    );
  }

  var array = TcpModuleSecondPage.prototype._ArrayComplement_(
    OldSystemVariableName,
    NewSystemVariableName
  );
  for (var i = 0; i < array.length; i++) {
    Global_TcpScalingVariable[number][array[i]] = null;
    delete Global_TcpScalingVariable[number][array[i]];
  }
};

TcpModuleSecondPage.prototype._BuildTcpBitwiseObject_ = function (number) {
  var OldSystemVariableName = new Array();
  if (typeof Global_TcpBitwiseVariable[number] == "undefined") {
    Global_TcpBitwiseVariable[number] = new Object();
  } else {
    OldSystemVariableName = Object.keys(Global_TcpBitwiseVariable[number]);
  }

  var NewSystemVariableName = new Array(),
    Data = new Object();
  var DataModelId = new Array("HoldingRegisters", "InputRegisters");
  for (var i = 0; i < DataModelId.length; i++) {
    Data = TcpModuleSecondPage.prototype._GetBitwiseTableOldData_(
      DataModelId[i]
    );
    TcpModuleSecondPage.prototype._SetNewTcpBitwiseVariableObjectValue_(
      DataModelId[i],
      Data,
      number
    );
    NewSystemVariableName = NewSystemVariableName.concat(
      TcpModuleSecondPage.prototype._BuildNewSystemVariableName_(
        DataModelId[i],
        Data
      )
    );
  }

  var array = TcpModuleSecondPage.prototype._ArrayComplement_(
    OldSystemVariableName,
    NewSystemVariableName
  );
  for (var i = 0; i < array.length; i++) {
    Global_TcpBitwiseVariable[number][array[i]] = null;
    delete Global_TcpBitwiseVariable[number][array[i]];
  }
};

TcpModuleSecondPage.prototype._GetGroupNumber_ = function (
  DataModelId,
  CurrentlyAddress
) {
  var Return;
  if (DataModelId == "CoilStatus") {
    Return = 1000000;
  } else if (DataModelId == "InputStatus") {
    Return = 2000000;
  } else if (DataModelId == "HoldingRegisters") {
    Return = 3000000;
  } else if (DataModelId == "InputRegisters") {
    Return = 4000000;
  }

  var Data = TcpModuleSecondPage.prototype._GetTotalTableOldData_(DataModelId);
  var Address = Object.keys(Data);
  for (var i = 0; i < Address.length; i++) {
    var StartAddress = parseInt(Address[i]);
    var DataNumber = parseInt(Data[Address[i]]["DataNumber"]);
    var DataType = Data[Address[i]]["DataType"];
    var MaxAddress =
      StartAddress +
      TcpModuleSecondPage.prototype._GetGridNumber_(DataType) * DataNumber;
    if (CurrentlyAddress >= StartAddress && CurrentlyAddress < MaxAddress) {
      Return = Return + (i + 1);
      break;
    }
  }
  return Return;
};

TcpModuleSecondPage.prototype._GetDataModel_ = function (string) {
  var Return;
  if (string == "DO") {
    Return = "Coil_Status";
  } else if (string == "DI") {
    Return = "Input_Status";
  } else if (string == "AO") {
    Return = "Holding_Registers";
  } else if (string == "AI") {
    Return = "Input_Registers";
  }
  return Return;
};

TcpModuleSecondPage.prototype._GetExistAddress_ = function (that) {
  var Return = new Array();
  var element = $(that).closest(".Table").find(".DynamicRow");
  var index = $(that).closest(".DynamicRow").index() - 1;
  for (var i = 0; i < element.length; i++) {
    if (i != index) {
      var StartAddress = parseInt(
        element.eq(i).find(".Row").eq(0).find("label").text()
      );
      var number = parseInt(
        element.eq(i).find(".Row").eq(1).find("label").text()
      );
      var DataType = element.eq(i).find(".Row").eq(2).find("label").text();
      var Grid = TcpModuleSecondPage.prototype._GetGridNumber_(DataType);
      var MaxAddress = StartAddress + Grid * number;
      for (var j = StartAddress; j < MaxAddress; j++) {
        Return.push(j);
      }
    }
  }
  return Return;
};

TcpModuleSecondPage.prototype._ConfirmButton_ = function (that) {
  $(that).closest(".Form").find(".Message").hide();
  $("#SettingForm").find(".Message").hide();
  var Element = $("#Main_Center-Content").find(".Body").eq(1).find(".Message");
  for (var i = 0; i < Element.length; i++) {
    if (
      Element.eq(i).is(":visible") == true &&
      Element.eq(i).css("color") != "rgb(34, 119, 0)"
    ) {
      $(that).closest(".Form").find(".Message").eq(1).show();
      return 0;
    }
  }
  var ContentSettings = $(".Form").eq(1).find(".Row");
  var number = parseInt(ContentSettings.eq(0).find(".Text").val());
  var ModuleName = ContentSettings.eq(1).find(".Text").val();
  TcpModuleFirstPage.prototype._BuildTcpModuleObject_(ModuleName, number);
  TcpModuleSecondPage.prototype._BuildTcpSettingObject_(number);
  TcpModuleSecondPage.prototype._BuildTcpVariableObject_(number);
  TcpModuleSecondPage.prototype._SynchronizeOtherServiceData_(number);
  TcpModuleSecondPage.prototype._BuildTcpScalingObject_(number);
  TcpModuleSecondPage.prototype._BuildTcpBitwiseObject_(number);
  TcpModuleSecondPage.prototype._SynchronizeOtherServiceScalingData_(number);
  TcpModuleSecondPage.prototype._SynchronizeOtherServiceBitwiseData_(number);
  $("#Main_Center-Content").find(".Body").eq(1).hide();
  $("#Main_Center-Content").find(".Body").eq(0).show();
  TcpModuleFirstPage.prototype._RedisplayUi_();
  var Class = new Path();
  Class.LoadPathHtml(
    $("#Left-List-TCP").text(),
    1,
    "main_PathTcpModule_click(this)"
  );
  Class = null;
};

TcpModuleSecondPage.prototype._NoConfirmButton_ = function () {
  $("#Main_Center-Content").find(".Body").eq(1).hide();
  $("#Main_Center-Content").find(".Body").eq(0).show();
  var Class = new Path();
  Class.LoadPathHtml(
    $("#Left-List-TCP").text(),
    1,
    "main_PathTcpModule_click(this)"
  );
  Class = null;
};
