BlockStatus.prototype._ShowUi_ = function()
{
	BlockStatus.prototype._RedisplayUi_();
}

BlockStatus.prototype._RedisplayUi_ = function()
{
	var Id = "#ModuleTable";
	$(Id).find(".Loading").show();
	$(Id).closest('.Row').find(".Message").hide();
	
	var ssocket = io.connect();
	ssocket.emit('GetUfwRules');
	ssocket.on("GetUfwRules", function (Return) {
		if(typeof(Return) == "object")
		{
			$(Id).find(".Loading").hide();
			var UfwRules = Return;
			BlockStatus.prototype._ShowTable_(UfwRules);
		}
	});
}

BlockStatus.prototype._ShowTable_ = function(UfwRules)
{
	var html = $(".Dynamic").html();

	var ObjectKey = Object.keys(UfwRules);
	for(var i=0; i<ObjectKey.length; i++)
	{
		$("#ModuleTable").append(html);
		$("#ModuleTable").find(".DynamicRow").eq(i).find(".Column").eq(0).text(ObjectKey[i]);
		$("#ModuleTable").find(".DynamicRow").eq(i).find(".Column").eq(2).text(UfwRules[ObjectKey[i]]["IP"]);
		$("#ModuleTable").find(".DynamicRow").eq(i).find(".Column").eq(3).text(UfwRules[ObjectKey[i]]["Port"]);
	}
}

BlockStatus.prototype._IsTickedBlockRules_ = function()
{
	var Return=false;
	var Id = "#ModuleTable";
	if($(Id).find(".DynamicRow").find(":checked").length >0)
	{
		Return=true;
	}
	return Return;
}

BlockStatus.prototype._GetAllTickedRules_ = function()
{
	var Return = new Array();
	var number;
	var Id = "#ModuleTable";
	var element = $(Id).find(".DynamicRow").find(":checked");
	var CheckedLength = element.length;
	for(var i=0; i<CheckedLength; i++)
	{
		number = element.eq(i).closest(".DynamicRow").find(".Column").eq(0).text();
		Return.push(number);
	}
	return Return;
}

BlockStatus.prototype._DeleteBlockRules_ = function(that)
{
	var RulesArray = BlockStatus.prototype._GetAllTickedRules_();
	var Result={"Input":null};
	var Class = new Transmission();
	Class.TransmissionArray("DeleteBlockRules", RulesArray, Result);
	var SetInterval = setInterval(function()
	{
		clearInterval(SetInterval);
		$("#ModuleTable").find(".Checkbox").eq(0).prop("checked", false);
		$("#ModuleTable").find(".DynamicRow").remove();
		BlockStatus.prototype._RedisplayUi_();
	},500);
}